# coding: utf-8

# flake8: noqa

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.0.0"

# import apis into sdk package
from clio-cli.api.activities_api import ActivitiesApi
from clio-cli.api.activity_descriptions_api import ActivityDescriptionsApi
from clio-cli.api.activity_rates_api import ActivityRatesApi
from clio-cli.api.allocations_api import AllocationsApi
from clio-cli.api.bank_accounts_api import BankAccountsApi
from clio-cli.api.bank_transactions_api import BankTransactionsApi
from clio-cli.api.bank_transfers_api import BankTransfersApi
from clio-cli.api.bill_themes_api import BillThemesApi
from clio-cli.api.billable_clients_api import BillableClientsApi
from clio-cli.api.billable_matters_api import BillableMattersApi
from clio-cli.api.billing_settings_api import BillingSettingsApi
from clio-cli.api.bills_api import BillsApi
from clio-cli.api.calendar_entries_api import CalendarEntriesApi
from clio-cli.api.calendar_entry_event_types_api import CalendarEntryEventTypesApi
from clio-cli.api.calendar_visibilities_api import CalendarVisibilitiesApi
from clio-cli.api.calendars_api import CalendarsApi
from clio-cli.api.civil_certificated_rates_api import CivilCertificatedRatesApi
from clio-cli.api.civil_controlled_rates_api import CivilControlledRatesApi
from clio-cli.api.clients_api import ClientsApi
from clio-cli.api.clio_payments_links_api import ClioPaymentsLinksApi
from clio-cli.api.clio_payments_payments_api import ClioPaymentsPaymentsApi
from clio-cli.api.comments_api import CommentsApi
from clio-cli.api.communications_api import CommunicationsApi
from clio-cli.api.contacts_api import ContactsApi
from clio-cli.api.conversation_messages_api import ConversationMessagesApi
from clio-cli.api.conversations_api import ConversationsApi
from clio-cli.api.credit_memos_api import CreditMemosApi
from clio-cli.api.criminal_controlled_rates_api import CriminalControlledRatesApi
from clio-cli.api.currencies_api import CurrenciesApi
from clio-cli.api.custom_actions_api import CustomActionsApi
from clio-cli.api.custom_field_sets_api import CustomFieldSetsApi
from clio-cli.api.custom_fields_api import CustomFieldsApi
from clio-cli.api.damages_api import DamagesApi
from clio-cli.api.document_archives_api import DocumentArchivesApi
from clio-cli.api.document_automations_api import DocumentAutomationsApi
from clio-cli.api.document_categories_api import DocumentCategoriesApi
from clio-cli.api.document_templates_api import DocumentTemplatesApi
from clio-cli.api.document_versions_api import DocumentVersionsApi
from clio-cli.api.documents_api import DocumentsApi
from clio-cli.api.event_metrics_api import EventMetricsApi
from clio-cli.api.expense_categories_api import ExpenseCategoriesApi
from clio-cli.api.folders_api import FoldersApi
from clio-cli.api.grant_funding_sources_api import GrantFundingSourcesApi
from clio-cli.api.grants_api import GrantsApi
from clio-cli.api.groups_api import GroupsApi
from clio-cli.api.interest_charges_api import InterestChargesApi
from clio-cli.api.jurisdictions_api import JurisdictionsApi
from clio-cli.api.jurisdictions_to_triggers_api import JurisdictionsToTriggersApi
from clio-cli.api.line_items_api import LineItemsApi
from clio-cli.api.log_entries_api import LogEntriesApi
from clio-cli.api.matter_contacts_api import MatterContactsApi
from clio-cli.api.matter_dockets_api import MatterDocketsApi
from clio-cli.api.matter_stages_api import MatterStagesApi
from clio-cli.api.matters_api import MattersApi
from clio-cli.api.medical_bills_api import MedicalBillsApi
from clio-cli.api.medical_records_api import MedicalRecordsApi
from clio-cli.api.medical_records_details_api import MedicalRecordsDetailsApi
from clio-cli.api.my_events_api import MyEventsApi
from clio-cli.api.notes_api import NotesApi
from clio-cli.api.outstanding_client_balances_api import OutstandingClientBalancesApi
from clio-cli.api.practice_areas_api import PracticeAreasApi
from clio-cli.api.related_contacts_api import RelatedContactsApi
from clio-cli.api.relationships_api import RelationshipsApi
from clio-cli.api.reminders_api import RemindersApi
from clio-cli.api.report_presets_api import ReportPresetsApi
from clio-cli.api.report_schedules_api import ReportSchedulesApi
from clio-cli.api.reports_api import ReportsApi
from clio-cli.api.service_types_api import ServiceTypesApi
from clio-cli.api.task_template_lists_api import TaskTemplateListsApi
from clio-cli.api.task_templates_api import TaskTemplatesApi
from clio-cli.api.task_types_api import TaskTypesApi
from clio-cli.api.tasks_api import TasksApi
from clio-cli.api.text_snippets_api import TextSnippetsApi
from clio-cli.api.timers_api import TimersApi
from clio-cli.api.trust_line_items_api import TrustLineItemsApi
from clio-cli.api.trust_requests_api import TrustRequestsApi
from clio-cli.api.users_api import UsersApi
from clio-cli.api.utbms_codes_api import UtbmsCodesApi
from clio-cli.api.utbms_sets_api import UtbmsSetsApi
from clio-cli.api.webhooks_api import WebhooksApi

# import ApiClient
from clio-cli.api_response import ApiResponse
from clio-cli.api_client import ApiClient
from clio-cli.configuration import Configuration
from clio-cli.exceptions import OpenApiException
from clio-cli.exceptions import ApiTypeError
from clio-cli.exceptions import ApiValueError
from clio-cli.exceptions import ApiKeyError
from clio-cli.exceptions import ApiAttributeError
from clio-cli.exceptions import ApiException

# import models into sdk package
from clio-cli.models.account import Account
from clio-cli.models.account_balance_base import AccountBalanceBase
from clio-cli.models.account_base import AccountBase
from clio-cli.models.activity import Activity
from clio-cli.models.activity_base import ActivityBase
from clio-cli.models.activity_calendar_entry_base import ActivityCalendarEntryBase
from clio-cli.models.activity_create_request import ActivityCreateRequest
from clio-cli.models.activity_create_request_data import ActivityCreateRequestData
from clio-cli.models.activity_create_request_data_activity_description import ActivityCreateRequestDataActivityDescription
from clio-cli.models.activity_create_request_data_calendar_entry import ActivityCreateRequestDataCalendarEntry
from clio-cli.models.activity_create_request_data_client_portal import ActivityCreateRequestDataClientPortal
from clio-cli.models.activity_create_request_data_communication import ActivityCreateRequestDataCommunication
from clio-cli.models.activity_create_request_data_contact_note import ActivityCreateRequestDataContactNote
from clio-cli.models.activity_create_request_data_expense_category import ActivityCreateRequestDataExpenseCategory
from clio-cli.models.activity_create_request_data_matter import ActivityCreateRequestDataMatter
from clio-cli.models.activity_create_request_data_task import ActivityCreateRequestDataTask
from clio-cli.models.activity_create_request_data_text_message_conversation import ActivityCreateRequestDataTextMessageConversation
from clio-cli.models.activity_create_request_data_user import ActivityCreateRequestDataUser
from clio-cli.models.activity_create_request_data_utbms_expense import ActivityCreateRequestDataUtbmsExpense
from clio-cli.models.activity_create_request_data_vendor import ActivityCreateRequestDataVendor
from clio-cli.models.activity_description import ActivityDescription
from clio-cli.models.activity_description_base import ActivityDescriptionBase
from clio-cli.models.activity_description_create_request import ActivityDescriptionCreateRequest
from clio-cli.models.activity_description_create_request_data import ActivityDescriptionCreateRequestData
from clio-cli.models.activity_description_create_request_data_groups_inner import ActivityDescriptionCreateRequestDataGroupsInner
from clio-cli.models.activity_description_create_request_data_rate import ActivityDescriptionCreateRequestDataRate
from clio-cli.models.activity_description_list import ActivityDescriptionList
from clio-cli.models.activity_description_rate_base import ActivityDescriptionRateBase
from clio-cli.models.activity_description_show import ActivityDescriptionShow
from clio-cli.models.activity_description_update_request import ActivityDescriptionUpdateRequest
from clio-cli.models.activity_description_update_request_data import ActivityDescriptionUpdateRequestData
from clio-cli.models.activity_description_update_request_data_groups_inner import ActivityDescriptionUpdateRequestDataGroupsInner
from clio-cli.models.activity_list import ActivityList
from clio-cli.models.activity_rate import ActivityRate
from clio-cli.models.activity_rate_base import ActivityRateBase
from clio-cli.models.activity_rate_create_request import ActivityRateCreateRequest
from clio-cli.models.activity_rate_create_request_data import ActivityRateCreateRequestData
from clio-cli.models.activity_rate_list import ActivityRateList
from clio-cli.models.activity_rate_show import ActivityRateShow
from clio-cli.models.activity_show import ActivityShow
from clio-cli.models.activity_task_base import ActivityTaskBase
from clio-cli.models.activity_text_message_conversation_base import ActivityTextMessageConversationBase
from clio-cli.models.activity_update_request import ActivityUpdateRequest
from clio-cli.models.activity_update_request_data import ActivityUpdateRequestData
from clio-cli.models.address_base import AddressBase
from clio-cli.models.allocation import Allocation
from clio-cli.models.allocation_base import AllocationBase
from clio-cli.models.allocation_list import AllocationList
from clio-cli.models.allocation_show import AllocationShow
from clio-cli.models.attendee_base import AttendeeBase
from clio-cli.models.avatar_base import AvatarBase
from clio-cli.models.balance import Balance
from clio-cli.models.balance_base import BalanceBase
from clio-cli.models.bank_account import BankAccount
from clio-cli.models.bank_account_base import BankAccountBase
from clio-cli.models.bank_account_create_request import BankAccountCreateRequest
from clio-cli.models.bank_account_create_request_data import BankAccountCreateRequestData
from clio-cli.models.bank_account_list import BankAccountList
from clio-cli.models.bank_account_show import BankAccountShow
from clio-cli.models.bank_account_update_request import BankAccountUpdateRequest
from clio-cli.models.bank_account_update_request_data import BankAccountUpdateRequestData
from clio-cli.models.bank_transaction import BankTransaction
from clio-cli.models.bank_transaction_base import BankTransactionBase
from clio-cli.models.bank_transaction_list import BankTransactionList
from clio-cli.models.bank_transaction_show import BankTransactionShow
from clio-cli.models.bank_transfer import BankTransfer
from clio-cli.models.bank_transfer_base import BankTransferBase
from clio-cli.models.bank_transfer_show import BankTransferShow
from clio-cli.models.bill import Bill
from clio-cli.models.bill_base import BillBase
from clio-cli.models.bill_list import BillList
from clio-cli.models.bill_recipient import BillRecipient
from clio-cli.models.bill_recipient_base import BillRecipientBase
from clio-cli.models.bill_recipient_contact_base import BillRecipientContactBase
from clio-cli.models.bill_show import BillShow
from clio-cli.models.bill_theme import BillTheme
from clio-cli.models.bill_theme_base import BillThemeBase
from clio-cli.models.bill_theme_list import BillThemeList
from clio-cli.models.bill_theme_show import BillThemeShow
from clio-cli.models.bill_theme_update_request import BillThemeUpdateRequest
from clio-cli.models.bill_theme_update_request_data import BillThemeUpdateRequestData
from clio-cli.models.bill_update_request import BillUpdateRequest
from clio-cli.models.bill_update_request_data import BillUpdateRequestData
from clio-cli.models.bill_update_request_data_bill_theme import BillUpdateRequestDataBillTheme
from clio-cli.models.bill_update_request_data_discount import BillUpdateRequestDataDiscount
from clio-cli.models.bill_update_request_data_interest import BillUpdateRequestDataInterest
from clio-cli.models.billable_client import BillableClient
from clio-cli.models.billable_client_base import BillableClientBase
from clio-cli.models.billable_client_list import BillableClientList
from clio-cli.models.billable_matter import BillableMatter
from clio-cli.models.billable_matter_base import BillableMatterBase
from clio-cli.models.billable_matter_list import BillableMatterList
from clio-cli.models.billable_matter_show import BillableMatterShow
from clio-cli.models.billing_setting import BillingSetting
from clio-cli.models.billing_setting_base import BillingSettingBase
from clio-cli.models.billing_setting_show import BillingSettingShow
from clio-cli.models.calendar import Calendar
from clio-cli.models.calendar_base import CalendarBase
from clio-cli.models.calendar_create_request import CalendarCreateRequest
from clio-cli.models.calendar_create_request_data import CalendarCreateRequestData
from clio-cli.models.calendar_entry import CalendarEntry
from clio-cli.models.calendar_entry_base import CalendarEntryBase
from clio-cli.models.calendar_entry_create_request import CalendarEntryCreateRequest
from clio-cli.models.calendar_entry_create_request_data import CalendarEntryCreateRequestData
from clio-cli.models.calendar_entry_create_request_data_attendees_inner import CalendarEntryCreateRequestDataAttendeesInner
from clio-cli.models.calendar_entry_create_request_data_calendar_entry_event_type import CalendarEntryCreateRequestDataCalendarEntryEventType
from clio-cli.models.calendar_entry_create_request_data_calendar_owner import CalendarEntryCreateRequestDataCalendarOwner
from clio-cli.models.calendar_entry_create_request_data_conference_meeting import CalendarEntryCreateRequestDataConferenceMeeting
from clio-cli.models.calendar_entry_create_request_data_external_properties_inner import CalendarEntryCreateRequestDataExternalPropertiesInner
from clio-cli.models.calendar_entry_create_request_data_matter import CalendarEntryCreateRequestDataMatter
from clio-cli.models.calendar_entry_event_type import CalendarEntryEventType
from clio-cli.models.calendar_entry_event_type_base import CalendarEntryEventTypeBase
from clio-cli.models.calendar_entry_event_type_create_request import CalendarEntryEventTypeCreateRequest
from clio-cli.models.calendar_entry_event_type_create_request_data import CalendarEntryEventTypeCreateRequestData
from clio-cli.models.calendar_entry_event_type_update_request import CalendarEntryEventTypeUpdateRequest
from clio-cli.models.calendar_entry_event_type_update_request_data import CalendarEntryEventTypeUpdateRequestData
from clio-cli.models.calendar_entry_list import CalendarEntryList
from clio-cli.models.calendar_entry_show import CalendarEntryShow
from clio-cli.models.calendar_entry_update_request import CalendarEntryUpdateRequest
from clio-cli.models.calendar_entry_update_request_data import CalendarEntryUpdateRequestData
from clio-cli.models.calendar_entry_update_request_data_calendar_owner import CalendarEntryUpdateRequestDataCalendarOwner
from clio-cli.models.calendar_entry_update_request_data_external_properties_inner import CalendarEntryUpdateRequestDataExternalPropertiesInner
from clio-cli.models.calendar_list import CalendarList
from clio-cli.models.calendar_show import CalendarShow
from clio-cli.models.calendar_update_request import CalendarUpdateRequest
from clio-cli.models.calendar_update_request_data import CalendarUpdateRequestData
from clio-cli.models.calendar_visibility import CalendarVisibility
from clio-cli.models.calendar_visibility_base import CalendarVisibilityBase
from clio-cli.models.calendar_visibility_list import CalendarVisibilityList
from clio-cli.models.calendar_visibility_show import CalendarVisibilityShow
from clio-cli.models.calendar_visibility_update_request import CalendarVisibilityUpdateRequest
from clio-cli.models.calendar_visibility_update_request_data import CalendarVisibilityUpdateRequestData
from clio-cli.models.cascading_task_template_base import CascadingTaskTemplateBase
from clio-cli.models.client import Client
from clio-cli.models.client_base import ClientBase
from clio-cli.models.client_portal_base import ClientPortalBase
from clio-cli.models.client_show import ClientShow
from clio-cli.models.clio_creator_base import ClioCreatorBase
from clio-cli.models.clio_payments_link import ClioPaymentsLink
from clio-cli.models.clio_payments_link_base import ClioPaymentsLinkBase
from clio-cli.models.clio_payments_link_create_request import ClioPaymentsLinkCreateRequest
from clio-cli.models.clio_payments_link_create_request_data import ClioPaymentsLinkCreateRequestData
from clio-cli.models.clio_payments_link_create_request_data_destination_account import ClioPaymentsLinkCreateRequestDataDestinationAccount
from clio-cli.models.clio_payments_link_create_request_data_destination_contact import ClioPaymentsLinkCreateRequestDataDestinationContact
from clio-cli.models.clio_payments_link_create_request_data_subject import ClioPaymentsLinkCreateRequestDataSubject
from clio-cli.models.clio_payments_link_list import ClioPaymentsLinkList
from clio-cli.models.clio_payments_link_show import ClioPaymentsLinkShow
from clio-cli.models.clio_payments_link_update_request import ClioPaymentsLinkUpdateRequest
from clio-cli.models.clio_payments_link_update_request_data import ClioPaymentsLinkUpdateRequestData
from clio-cli.models.clio_payments_payment import ClioPaymentsPayment
from clio-cli.models.clio_payments_payment_base import ClioPaymentsPaymentBase
from clio-cli.models.clio_payments_payment_list import ClioPaymentsPaymentList
from clio-cli.models.clio_payments_payment_show import ClioPaymentsPaymentShow
from clio-cli.models.comment import Comment
from clio-cli.models.comment_base import CommentBase
from clio-cli.models.comment_create_request import CommentCreateRequest
from clio-cli.models.comment_create_request_data import CommentCreateRequestData
from clio-cli.models.comment_create_request_data_item import CommentCreateRequestDataItem
from clio-cli.models.comment_list import CommentList
from clio-cli.models.comment_show import CommentShow
from clio-cli.models.comment_update_request import CommentUpdateRequest
from clio-cli.models.comment_update_request_data import CommentUpdateRequestData
from clio-cli.models.comment_update_request_data_item import CommentUpdateRequestDataItem
from clio-cli.models.communication import Communication
from clio-cli.models.communication_base import CommunicationBase
from clio-cli.models.communication_create_request import CommunicationCreateRequest
from clio-cli.models.communication_create_request_data import CommunicationCreateRequestData
from clio-cli.models.communication_create_request_data_external_properties_inner import CommunicationCreateRequestDataExternalPropertiesInner
from clio-cli.models.communication_create_request_data_matter import CommunicationCreateRequestDataMatter
from clio-cli.models.communication_create_request_data_notification_event_subscribers_inner import CommunicationCreateRequestDataNotificationEventSubscribersInner
from clio-cli.models.communication_create_request_data_receivers_inner import CommunicationCreateRequestDataReceiversInner
from clio-cli.models.communication_create_request_data_senders_inner import CommunicationCreateRequestDataSendersInner
from clio-cli.models.communication_eml_file_base import CommunicationEmlFileBase
from clio-cli.models.communication_list import CommunicationList
from clio-cli.models.communication_show import CommunicationShow
from clio-cli.models.communication_update_request import CommunicationUpdateRequest
from clio-cli.models.communication_update_request_data import CommunicationUpdateRequestData
from clio-cli.models.communication_update_request_data_external_properties_inner import CommunicationUpdateRequestDataExternalPropertiesInner
from clio-cli.models.communication_update_request_data_notification_event_subscribers_inner import CommunicationUpdateRequestDataNotificationEventSubscribersInner
from clio-cli.models.conference_meeting_base import ConferenceMeetingBase
from clio-cli.models.contact import Contact
from clio-cli.models.contact_base import ContactBase
from clio-cli.models.contact_create_request import ContactCreateRequest
from clio-cli.models.contact_create_request_data import ContactCreateRequestData
from clio-cli.models.contact_create_request_data_addresses_inner import ContactCreateRequestDataAddressesInner
from clio-cli.models.contact_create_request_data_avatar import ContactCreateRequestDataAvatar
from clio-cli.models.contact_create_request_data_co_counsel_rate import ContactCreateRequestDataCoCounselRate
from clio-cli.models.contact_create_request_data_company import ContactCreateRequestDataCompany
from clio-cli.models.contact_create_request_data_custom_field_set_associations_inner import ContactCreateRequestDataCustomFieldSetAssociationsInner
from clio-cli.models.contact_create_request_data_custom_field_set_associations_inner_custom_field_set import ContactCreateRequestDataCustomFieldSetAssociationsInnerCustomFieldSet
from clio-cli.models.contact_create_request_data_custom_field_values_inner import ContactCreateRequestDataCustomFieldValuesInner
from clio-cli.models.contact_create_request_data_custom_field_values_inner_custom_field import ContactCreateRequestDataCustomFieldValuesInnerCustomField
from clio-cli.models.contact_create_request_data_email_addresses_inner import ContactCreateRequestDataEmailAddressesInner
from clio-cli.models.contact_create_request_data_instant_messengers_inner import ContactCreateRequestDataInstantMessengersInner
from clio-cli.models.contact_create_request_data_phone_numbers_inner import ContactCreateRequestDataPhoneNumbersInner
from clio-cli.models.contact_create_request_data_web_sites_inner import ContactCreateRequestDataWebSitesInner
from clio-cli.models.contact_list import ContactList
from clio-cli.models.contact_show import ContactShow
from clio-cli.models.contact_update_request import ContactUpdateRequest
from clio-cli.models.contact_update_request_data import ContactUpdateRequestData
from clio-cli.models.contact_update_request_data_addresses_inner import ContactUpdateRequestDataAddressesInner
from clio-cli.models.contact_update_request_data_custom_field_set_associations_inner import ContactUpdateRequestDataCustomFieldSetAssociationsInner
from clio-cli.models.contact_update_request_data_custom_field_set_associations_inner_custom_field_set import ContactUpdateRequestDataCustomFieldSetAssociationsInnerCustomFieldSet
from clio-cli.models.contact_update_request_data_custom_field_values_inner import ContactUpdateRequestDataCustomFieldValuesInner
from clio-cli.models.contact_update_request_data_custom_field_values_inner_custom_field import ContactUpdateRequestDataCustomFieldValuesInnerCustomField
from clio-cli.models.contact_update_request_data_email_addresses_inner import ContactUpdateRequestDataEmailAddressesInner
from clio-cli.models.contact_update_request_data_instant_messengers_inner import ContactUpdateRequestDataInstantMessengersInner
from clio-cli.models.contact_update_request_data_phone_numbers_inner import ContactUpdateRequestDataPhoneNumbersInner
from clio-cli.models.contact_update_request_data_web_sites_inner import ContactUpdateRequestDataWebSitesInner
from clio-cli.models.contingency_fee_base import ContingencyFeeBase
from clio-cli.models.conversation import Conversation
from clio-cli.models.conversation_base import ConversationBase
from clio-cli.models.conversation_list import ConversationList
from clio-cli.models.conversation_membership import ConversationMembership
from clio-cli.models.conversation_membership_base import ConversationMembershipBase
from clio-cli.models.conversation_message import ConversationMessage
from clio-cli.models.conversation_message_base import ConversationMessageBase
from clio-cli.models.conversation_message_create_request import ConversationMessageCreateRequest
from clio-cli.models.conversation_message_create_request_data import ConversationMessageCreateRequestData
from clio-cli.models.conversation_message_create_request_data_attachment import ConversationMessageCreateRequestDataAttachment
from clio-cli.models.conversation_message_create_request_data_conversation import ConversationMessageCreateRequestDataConversation
from clio-cli.models.conversation_message_create_request_data_matter import ConversationMessageCreateRequestDataMatter
from clio-cli.models.conversation_message_create_request_data_receivers_inner import ConversationMessageCreateRequestDataReceiversInner
from clio-cli.models.conversation_message_list import ConversationMessageList
from clio-cli.models.conversation_message_show import ConversationMessageShow
from clio-cli.models.conversation_show import ConversationShow
from clio-cli.models.conversation_update_request import ConversationUpdateRequest
from clio-cli.models.conversation_update_request_data import ConversationUpdateRequestData
from clio-cli.models.conversation_update_request_data_matter import ConversationUpdateRequestDataMatter
from clio-cli.models.credit_memo import CreditMemo
from clio-cli.models.credit_memo_base import CreditMemoBase
from clio-cli.models.credit_memo_list import CreditMemoList
from clio-cli.models.credit_memo_show import CreditMemoShow
from clio-cli.models.currency import Currency
from clio-cli.models.currency_base import CurrencyBase
from clio-cli.models.currency_list import CurrencyList
from clio-cli.models.custom_action import CustomAction
from clio-cli.models.custom_action_base import CustomActionBase
from clio-cli.models.custom_action_create_request import CustomActionCreateRequest
from clio-cli.models.custom_action_create_request_data import CustomActionCreateRequestData
from clio-cli.models.custom_action_list import CustomActionList
from clio-cli.models.custom_action_show import CustomActionShow
from clio-cli.models.custom_action_update_request import CustomActionUpdateRequest
from clio-cli.models.custom_action_update_request_data import CustomActionUpdateRequestData
from clio-cli.models.custom_field import CustomField
from clio-cli.models.custom_field_base import CustomFieldBase
from clio-cli.models.custom_field_create_request import CustomFieldCreateRequest
from clio-cli.models.custom_field_create_request_data import CustomFieldCreateRequestData
from clio-cli.models.custom_field_create_request_data_picklist_options_inner import CustomFieldCreateRequestDataPicklistOptionsInner
from clio-cli.models.custom_field_list import CustomFieldList
from clio-cli.models.custom_field_matter_selection import CustomFieldMatterSelection
from clio-cli.models.custom_field_matter_selection_base import CustomFieldMatterSelectionBase
from clio-cli.models.custom_field_set import CustomFieldSet
from clio-cli.models.custom_field_set_association_base import CustomFieldSetAssociationBase
from clio-cli.models.custom_field_set_base import CustomFieldSetBase
from clio-cli.models.custom_field_set_create_request import CustomFieldSetCreateRequest
from clio-cli.models.custom_field_set_create_request_data import CustomFieldSetCreateRequestData
from clio-cli.models.custom_field_set_list import CustomFieldSetList
from clio-cli.models.custom_field_set_show import CustomFieldSetShow
from clio-cli.models.custom_field_set_update_request import CustomFieldSetUpdateRequest
from clio-cli.models.custom_field_set_update_request_data import CustomFieldSetUpdateRequestData
from clio-cli.models.custom_field_show import CustomFieldShow
from clio-cli.models.custom_field_update_request import CustomFieldUpdateRequest
from clio-cli.models.custom_field_update_request_data import CustomFieldUpdateRequestData
from clio-cli.models.custom_field_value import CustomFieldValue
from clio-cli.models.custom_field_value_base import CustomFieldValueBase
from clio-cli.models.damage import Damage
from clio-cli.models.damage_base import DamageBase
from clio-cli.models.damage_create_request import DamageCreateRequest
from clio-cli.models.damage_create_request_data import DamageCreateRequestData
from clio-cli.models.damage_list import DamageList
from clio-cli.models.damage_show import DamageShow
from clio-cli.models.damage_update_request import DamageUpdateRequest
from clio-cli.models.damage_update_request_data import DamageUpdateRequestData
from clio-cli.models.discount_base import DiscountBase
from clio-cli.models.document import Document
from clio-cli.models.document_archive import DocumentArchive
from clio-cli.models.document_archive_base import DocumentArchiveBase
from clio-cli.models.document_archive_create_request import DocumentArchiveCreateRequest
from clio-cli.models.document_archive_create_request_data import DocumentArchiveCreateRequestData
from clio-cli.models.document_archive_create_request_data_items_inner import DocumentArchiveCreateRequestDataItemsInner
from clio-cli.models.document_archive_show import DocumentArchiveShow
from clio-cli.models.document_automation import DocumentAutomation
from clio-cli.models.document_automation_base import DocumentAutomationBase
from clio-cli.models.document_automation_create_request import DocumentAutomationCreateRequest
from clio-cli.models.document_automation_create_request_data import DocumentAutomationCreateRequestData
from clio-cli.models.document_automation_create_request_data_document_template import DocumentAutomationCreateRequestDataDocumentTemplate
from clio-cli.models.document_automation_create_request_data_matter import DocumentAutomationCreateRequestDataMatter
from clio-cli.models.document_automation_list import DocumentAutomationList
from clio-cli.models.document_automation_show import DocumentAutomationShow
from clio-cli.models.document_base import DocumentBase
from clio-cli.models.document_category import DocumentCategory
from clio-cli.models.document_category_base import DocumentCategoryBase
from clio-cli.models.document_category_create_request import DocumentCategoryCreateRequest
from clio-cli.models.document_category_create_request_data import DocumentCategoryCreateRequestData
from clio-cli.models.document_category_list import DocumentCategoryList
from clio-cli.models.document_category_show import DocumentCategoryShow
from clio-cli.models.document_category_update_request import DocumentCategoryUpdateRequest
from clio-cli.models.document_category_update_request_data import DocumentCategoryUpdateRequestData
from clio-cli.models.document_copy_request import DocumentCopyRequest
from clio-cli.models.document_copy_request_data import DocumentCopyRequestData
from clio-cli.models.document_copy_request_data_document_category import DocumentCopyRequestDataDocumentCategory
from clio-cli.models.document_copy_request_data_external_properties_inner import DocumentCopyRequestDataExternalPropertiesInner
from clio-cli.models.document_copy_request_data_parent import DocumentCopyRequestDataParent
from clio-cli.models.document_create_request import DocumentCreateRequest
from clio-cli.models.document_create_request_data import DocumentCreateRequestData
from clio-cli.models.document_create_request_data_external_properties_inner import DocumentCreateRequestDataExternalPropertiesInner
from clio-cli.models.document_create_request_data_multiparts_inner import DocumentCreateRequestDataMultipartsInner
from clio-cli.models.document_list import DocumentList
from clio-cli.models.document_show import DocumentShow
from clio-cli.models.document_template import DocumentTemplate
from clio-cli.models.document_template_base import DocumentTemplateBase
from clio-cli.models.document_template_create_request import DocumentTemplateCreateRequest
from clio-cli.models.document_template_create_request_data import DocumentTemplateCreateRequestData
from clio-cli.models.document_template_create_request_data_document_category import DocumentTemplateCreateRequestDataDocumentCategory
from clio-cli.models.document_template_list import DocumentTemplateList
from clio-cli.models.document_template_show import DocumentTemplateShow
from clio-cli.models.document_template_update_request import DocumentTemplateUpdateRequest
from clio-cli.models.document_template_update_request_data import DocumentTemplateUpdateRequestData
from clio-cli.models.document_update_request import DocumentUpdateRequest
from clio-cli.models.document_update_request_data import DocumentUpdateRequestData
from clio-cli.models.document_update_request_data_multiparts_inner import DocumentUpdateRequestDataMultipartsInner
from clio-cli.models.document_update_request_data_parent import DocumentUpdateRequestDataParent
from clio-cli.models.document_version import DocumentVersion
from clio-cli.models.document_version_base import DocumentVersionBase
from clio-cli.models.document_version_list import DocumentVersionList
from clio-cli.models.email_address_base import EmailAddressBase
from clio-cli.models.error import Error
from clio-cli.models.error_detail import ErrorDetail
from clio-cli.models.event import Event
from clio-cli.models.event_base import EventBase
from clio-cli.models.event_metrics import EventMetrics
from clio-cli.models.event_metrics_base import EventMetricsBase
from clio-cli.models.event_metrics_show import EventMetricsShow
from clio-cli.models.evergreen_retainer_base import EvergreenRetainerBase
from clio-cli.models.expense_category import ExpenseCategory
from clio-cli.models.expense_category_base import ExpenseCategoryBase
from clio-cli.models.expense_category_create_request import ExpenseCategoryCreateRequest
from clio-cli.models.expense_category_create_request_data import ExpenseCategoryCreateRequestData
from clio-cli.models.expense_category_create_request_data_groups_inner import ExpenseCategoryCreateRequestDataGroupsInner
from clio-cli.models.expense_category_create_request_data_utbms_code import ExpenseCategoryCreateRequestDataUtbmsCode
from clio-cli.models.expense_category_list import ExpenseCategoryList
from clio-cli.models.expense_category_show import ExpenseCategoryShow
from clio-cli.models.expense_category_update_request import ExpenseCategoryUpdateRequest
from clio-cli.models.expense_category_update_request_data import ExpenseCategoryUpdateRequestData
from clio-cli.models.external_property_base import ExternalPropertyBase
from clio-cli.models.folder import Folder
from clio-cli.models.folder_base import FolderBase
from clio-cli.models.folder_create_request import FolderCreateRequest
from clio-cli.models.folder_create_request_data import FolderCreateRequestData
from clio-cli.models.folder_create_request_data_document_category import FolderCreateRequestDataDocumentCategory
from clio-cli.models.folder_create_request_data_external_properties_inner import FolderCreateRequestDataExternalPropertiesInner
from clio-cli.models.folder_create_request_data_parent import FolderCreateRequestDataParent
from clio-cli.models.folder_list import FolderList
from clio-cli.models.folder_show import FolderShow
from clio-cli.models.folder_update_request import FolderUpdateRequest
from clio-cli.models.folder_update_request_data import FolderUpdateRequestData
from clio-cli.models.folder_update_request_data_external_properties_inner import FolderUpdateRequestDataExternalPropertiesInner
from clio-cli.models.folder_update_request_data_parent import FolderUpdateRequestDataParent
from clio-cli.models.grant import Grant
from clio-cli.models.grant_base import GrantBase
from clio-cli.models.grant_create_request import GrantCreateRequest
from clio-cli.models.grant_create_request_data import GrantCreateRequestData
from clio-cli.models.grant_funding_source import GrantFundingSource
from clio-cli.models.grant_funding_source_base import GrantFundingSourceBase
from clio-cli.models.grant_funding_source_create_request import GrantFundingSourceCreateRequest
from clio-cli.models.grant_funding_source_create_request_data import GrantFundingSourceCreateRequestData
from clio-cli.models.grant_funding_source_list import GrantFundingSourceList
from clio-cli.models.grant_funding_source_show import GrantFundingSourceShow
from clio-cli.models.grant_list import GrantList
from clio-cli.models.grant_show import GrantShow
from clio-cli.models.group import Group
from clio-cli.models.group_base import GroupBase
from clio-cli.models.group_create_request import GroupCreateRequest
from clio-cli.models.group_create_request_data import GroupCreateRequestData
from clio-cli.models.group_list import GroupList
from clio-cli.models.group_show import GroupShow
from clio-cli.models.ids_response import IdsResponse
from clio-cli.models.instant_messenger_base import InstantMessengerBase
from clio-cli.models.interest import Interest
from clio-cli.models.interest_base import InterestBase
from clio-cli.models.interest_charge import InterestCharge
from clio-cli.models.interest_charge_base import InterestChargeBase
from clio-cli.models.interest_charge_list import InterestChargeList
from clio-cli.models.item import Item
from clio-cli.models.item_base import ItemBase
from clio-cli.models.item_list import ItemList
from clio-cli.models.job_title_base import JobTitleBase
from clio-cli.models.jurisdiction import Jurisdiction
from clio-cli.models.jurisdiction_base import JurisdictionBase
from clio-cli.models.jurisdiction_list import JurisdictionList
from clio-cli.models.jurisdiction_show import JurisdictionShow
from clio-cli.models.jurisdictions_to_trigger import JurisdictionsToTrigger
from clio-cli.models.jurisdictions_to_trigger_base import JurisdictionsToTriggerBase
from clio-cli.models.jurisdictions_to_trigger_list import JurisdictionsToTriggerList
from clio-cli.models.jurisdictions_to_trigger_show import JurisdictionsToTriggerShow
from clio-cli.models.lauk_civil_certificated_rate import LaukCivilCertificatedRate
from clio-cli.models.lauk_civil_certificated_rate_base import LaukCivilCertificatedRateBase
from clio-cli.models.lauk_civil_certificated_rate_list import LaukCivilCertificatedRateList
from clio-cli.models.lauk_civil_controlled_rate import LaukCivilControlledRate
from clio-cli.models.lauk_civil_controlled_rate_base import LaukCivilControlledRateBase
from clio-cli.models.lauk_civil_controlled_rate_list import LaukCivilControlledRateList
from clio-cli.models.lauk_criminal_controlled_rate import LaukCriminalControlledRate
from clio-cli.models.lauk_criminal_controlled_rate_base import LaukCriminalControlledRateBase
from clio-cli.models.lauk_criminal_controlled_rate_list import LaukCriminalControlledRateList
from clio-cli.models.lauk_expense_category import LaukExpenseCategory
from clio-cli.models.lauk_expense_category_base import LaukExpenseCategoryBase
from clio-cli.models.lauk_expense_category_list import LaukExpenseCategoryList
from clio-cli.models.legal_aid_uk_activity_base import LegalAidUkActivityBase
from clio-cli.models.legal_aid_uk_bill_base import LegalAidUkBillBase
from clio-cli.models.legal_aid_uk_contact_base import LegalAidUkContactBase
from clio-cli.models.legal_aid_uk_matter_base import LegalAidUkMatterBase
from clio-cli.models.lien_base import LienBase
from clio-cli.models.line_item import LineItem
from clio-cli.models.line_item_base import LineItemBase
from clio-cli.models.line_item_list import LineItemList
from clio-cli.models.line_item_show import LineItemShow
from clio-cli.models.line_item_totals_base import LineItemTotalsBase
from clio-cli.models.line_item_update_request import LineItemUpdateRequest
from clio-cli.models.line_item_update_request_data import LineItemUpdateRequestData
from clio-cli.models.line_item_update_request_data_activity import LineItemUpdateRequestDataActivity
from clio-cli.models.line_item_update_request_data_bill import LineItemUpdateRequestDataBill
from clio-cli.models.line_item_update_request_data_discount import LineItemUpdateRequestDataDiscount
from clio-cli.models.line_item_update_request_data_matter import LineItemUpdateRequestDataMatter
from clio-cli.models.linked_folder_base import LinkedFolderBase
from clio-cli.models.log_entry import LogEntry
from clio-cli.models.log_entry_base import LogEntryBase
from clio-cli.models.log_entry_list import LogEntryList
from clio-cli.models.matter import Matter
from clio-cli.models.matter_balance_base import MatterBalanceBase
from clio-cli.models.matter_base import MatterBase
from clio-cli.models.matter_bill_recipient import MatterBillRecipient
from clio-cli.models.matter_bill_recipient_base import MatterBillRecipientBase
from clio-cli.models.matter_budget_base import MatterBudgetBase
from clio-cli.models.matter_contacts import MatterContacts
from clio-cli.models.matter_contacts_base import MatterContactsBase
from clio-cli.models.matter_contacts_list import MatterContactsList
from clio-cli.models.matter_create_request import MatterCreateRequest
from clio-cli.models.matter_create_request_data import MatterCreateRequestData
from clio-cli.models.matter_create_request_data_client import MatterCreateRequestDataClient
from clio-cli.models.matter_create_request_data_custom_field_set_associations_inner import MatterCreateRequestDataCustomFieldSetAssociationsInner
from clio-cli.models.matter_create_request_data_custom_rate import MatterCreateRequestDataCustomRate
from clio-cli.models.matter_create_request_data_custom_rate_rates_inner import MatterCreateRequestDataCustomRateRatesInner
from clio-cli.models.matter_create_request_data_custom_rate_rates_inner_activity_description import MatterCreateRequestDataCustomRateRatesInnerActivityDescription
from clio-cli.models.matter_create_request_data_custom_rate_rates_inner_group import MatterCreateRequestDataCustomRateRatesInnerGroup
from clio-cli.models.matter_create_request_data_custom_rate_rates_inner_user import MatterCreateRequestDataCustomRateRatesInnerUser
from clio-cli.models.matter_create_request_data_evergreen_retainer import MatterCreateRequestDataEvergreenRetainer
from clio-cli.models.matter_create_request_data_evergreen_retainer_recipients_inner import MatterCreateRequestDataEvergreenRetainerRecipientsInner
from clio-cli.models.matter_create_request_data_group import MatterCreateRequestDataGroup
from clio-cli.models.matter_create_request_data_matter_budget import MatterCreateRequestDataMatterBudget
from clio-cli.models.matter_create_request_data_matter_stage import MatterCreateRequestDataMatterStage
from clio-cli.models.matter_create_request_data_originating_attorney import MatterCreateRequestDataOriginatingAttorney
from clio-cli.models.matter_create_request_data_practice_area import MatterCreateRequestDataPracticeArea
from clio-cli.models.matter_create_request_data_relationships_inner import MatterCreateRequestDataRelationshipsInner
from clio-cli.models.matter_create_request_data_relationships_inner_contact import MatterCreateRequestDataRelationshipsInnerContact
from clio-cli.models.matter_create_request_data_split_invoice_payers_inner import MatterCreateRequestDataSplitInvoicePayersInner
from clio-cli.models.matter_create_request_data_statute_of_limitations import MatterCreateRequestDataStatuteOfLimitations
from clio-cli.models.matter_create_request_data_statute_of_limitations_reminders_inner import MatterCreateRequestDataStatuteOfLimitationsRemindersInner
from clio-cli.models.matter_create_request_data_statute_of_limitations_reminders_inner_notification_method import MatterCreateRequestDataStatuteOfLimitationsRemindersInnerNotificationMethod
from clio-cli.models.matter_create_request_data_task_template_list_instances_inner import MatterCreateRequestDataTaskTemplateListInstancesInner
from clio-cli.models.matter_create_request_data_task_template_list_instances_inner_task_template_list import MatterCreateRequestDataTaskTemplateListInstancesInnerTaskTemplateList
from clio-cli.models.matter_custom_rate import MatterCustomRate
from clio-cli.models.matter_custom_rate_base import MatterCustomRateBase
from clio-cli.models.matter_docket import MatterDocket
from clio-cli.models.matter_docket_base import MatterDocketBase
from clio-cli.models.matter_docket_create_request import MatterDocketCreateRequest
from clio-cli.models.matter_docket_create_request_data import MatterDocketCreateRequestData
from clio-cli.models.matter_docket_create_request_data_jurisdiction import MatterDocketCreateRequestDataJurisdiction
from clio-cli.models.matter_docket_create_request_data_trigger import MatterDocketCreateRequestDataTrigger
from clio-cli.models.matter_docket_list import MatterDocketList
from clio-cli.models.matter_docket_show import MatterDocketShow
from clio-cli.models.matter_list import MatterList
from clio-cli.models.matter_show import MatterShow
from clio-cli.models.matter_stage import MatterStage
from clio-cli.models.matter_stage_base import MatterStageBase
from clio-cli.models.matter_stage_list import MatterStageList
from clio-cli.models.matter_update_request import MatterUpdateRequest
from clio-cli.models.matter_update_request_data import MatterUpdateRequestData
from clio-cli.models.matter_update_request_data_client import MatterUpdateRequestDataClient
from clio-cli.models.matter_update_request_data_custom_field_set_associations_inner import MatterUpdateRequestDataCustomFieldSetAssociationsInner
from clio-cli.models.matter_update_request_data_custom_field_values_inner import MatterUpdateRequestDataCustomFieldValuesInner
from clio-cli.models.matter_update_request_data_custom_rate import MatterUpdateRequestDataCustomRate
from clio-cli.models.matter_update_request_data_custom_rate_rates_inner import MatterUpdateRequestDataCustomRateRatesInner
from clio-cli.models.matter_update_request_data_custom_rate_rates_inner_user import MatterUpdateRequestDataCustomRateRatesInnerUser
from clio-cli.models.matter_update_request_data_evergreen_retainer import MatterUpdateRequestDataEvergreenRetainer
from clio-cli.models.matter_update_request_data_relationships_inner import MatterUpdateRequestDataRelationshipsInner
from clio-cli.models.matter_update_request_data_relationships_inner_contact import MatterUpdateRequestDataRelationshipsInnerContact
from clio-cli.models.matter_update_request_data_split_invoice_payers_inner import MatterUpdateRequestDataSplitInvoicePayersInner
from clio-cli.models.matter_update_request_data_statute_of_limitations import MatterUpdateRequestDataStatuteOfLimitations
from clio-cli.models.matter_update_request_data_statute_of_limitations_reminders_inner import MatterUpdateRequestDataStatuteOfLimitationsRemindersInner
from clio-cli.models.matter_update_request_data_statute_of_limitations_reminders_inner_notification_method import MatterUpdateRequestDataStatuteOfLimitationsRemindersInnerNotificationMethod
from clio-cli.models.matter_update_request_data_task_template_list_instances_inner import MatterUpdateRequestDataTaskTemplateListInstancesInner
from clio-cli.models.matter_update_request_data_task_template_list_instances_inner_task_template_list import MatterUpdateRequestDataTaskTemplateListInstancesInnerTaskTemplateList
from clio-cli.models.medical_bill import MedicalBill
from clio-cli.models.medical_bill_base import MedicalBillBase
from clio-cli.models.medical_bill_show import MedicalBillShow
from clio-cli.models.medical_bill_update_request import MedicalBillUpdateRequest
from clio-cli.models.medical_bill_update_request_data import MedicalBillUpdateRequestData
from clio-cli.models.medical_bill_update_request_data_payers_inner import MedicalBillUpdateRequestDataPayersInner
from clio-cli.models.medical_record import MedicalRecord
from clio-cli.models.medical_record_base import MedicalRecordBase
from clio-cli.models.medical_record_show import MedicalRecordShow
from clio-cli.models.medical_record_update_request import MedicalRecordUpdateRequest
from clio-cli.models.medical_record_update_request_data import MedicalRecordUpdateRequestData
from clio-cli.models.medical_records_request import MedicalRecordsRequest
from clio-cli.models.medical_records_request_base import MedicalRecordsRequestBase
from clio-cli.models.medical_records_request_create_request import MedicalRecordsRequestCreateRequest
from clio-cli.models.medical_records_request_create_request_data import MedicalRecordsRequestCreateRequestData
from clio-cli.models.medical_records_request_create_request_data_medical_bills_inner import MedicalRecordsRequestCreateRequestDataMedicalBillsInner
from clio-cli.models.medical_records_request_create_request_data_medical_bills_inner_payers_inner import MedicalRecordsRequestCreateRequestDataMedicalBillsInnerPayersInner
from clio-cli.models.medical_records_request_create_request_data_medical_records_inner import MedicalRecordsRequestCreateRequestDataMedicalRecordsInner
from clio-cli.models.medical_records_request_list import MedicalRecordsRequestList
from clio-cli.models.medical_records_request_show import MedicalRecordsRequestShow
from clio-cli.models.medical_records_request_update_request import MedicalRecordsRequestUpdateRequest
from clio-cli.models.medical_records_request_update_request_data import MedicalRecordsRequestUpdateRequestData
from clio-cli.models.medical_records_request_update_request_data_medical_bills_inner import MedicalRecordsRequestUpdateRequestDataMedicalBillsInner
from clio-cli.models.medical_records_request_update_request_data_medical_bills_inner_payers_inner import MedicalRecordsRequestUpdateRequestDataMedicalBillsInnerPayersInner
from clio-cli.models.medical_records_request_update_request_data_medical_records_inner import MedicalRecordsRequestUpdateRequestDataMedicalRecordsInner
from clio-cli.models.multipart import Multipart
from clio-cli.models.multipart_base import MultipartBase
from clio-cli.models.multipart_header_base import MultipartHeaderBase
from clio-cli.models.my_event import MyEvent
from clio-cli.models.my_event_list import MyEventList
from clio-cli.models.my_event_show import MyEventShow
from clio-cli.models.my_event_update_request import MyEventUpdateRequest
from clio-cli.models.my_event_update_request_data import MyEventUpdateRequestData
from clio-cli.models.note import Note
from clio-cli.models.note_base import NoteBase
from clio-cli.models.note_create_request import NoteCreateRequest
from clio-cli.models.note_create_request_data import NoteCreateRequestData
from clio-cli.models.note_create_request_data_contact import NoteCreateRequestDataContact
from clio-cli.models.note_create_request_data_matter import NoteCreateRequestDataMatter
from clio-cli.models.note_create_request_data_notification_event_subscribers_inner import NoteCreateRequestDataNotificationEventSubscribersInner
from clio-cli.models.note_list import NoteList
from clio-cli.models.note_show import NoteShow
from clio-cli.models.note_update_request import NoteUpdateRequest
from clio-cli.models.note_update_request_data import NoteUpdateRequestData
from clio-cli.models.note_update_request_data_notification_event_subscribers_inner import NoteUpdateRequestDataNotificationEventSubscribersInner
from clio-cli.models.notification_event_subscriber_base import NotificationEventSubscriberBase
from clio-cli.models.notification_method_base import NotificationMethodBase
from clio-cli.models.outstanding_client_balance import OutstandingClientBalance
from clio-cli.models.outstanding_client_balance_base import OutstandingClientBalanceBase
from clio-cli.models.outstanding_client_balance_list import OutstandingClientBalanceList
from clio-cli.models.participant import Participant
from clio-cli.models.participant_base import ParticipantBase
from clio-cli.models.payment import Payment
from clio-cli.models.payment_base import PaymentBase
from clio-cli.models.payment_profile_base import PaymentProfileBase
from clio-cli.models.phone_number_base import PhoneNumberBase
from clio-cli.models.picklist_option import PicklistOption
from clio-cli.models.picklist_option_base import PicklistOptionBase
from clio-cli.models.polymorphic_custom_rate import PolymorphicCustomRate
from clio-cli.models.polymorphic_custom_rate_activity_description_base import PolymorphicCustomRateActivityDescriptionBase
from clio-cli.models.polymorphic_custom_rate_base import PolymorphicCustomRateBase
from clio-cli.models.polymorphic_custom_rate_group_base import PolymorphicCustomRateGroupBase
from clio-cli.models.polymorphic_custom_rate_user_base import PolymorphicCustomRateUserBase
from clio-cli.models.polymorphic_object_base import PolymorphicObjectBase
from clio-cli.models.practice_area import PracticeArea
from clio-cli.models.practice_area_base import PracticeAreaBase
from clio-cli.models.practice_area_create_request import PracticeAreaCreateRequest
from clio-cli.models.practice_area_create_request_data import PracticeAreaCreateRequestData
from clio-cli.models.practice_area_list import PracticeAreaList
from clio-cli.models.practice_area_show import PracticeAreaShow
from clio-cli.models.practice_area_update_request import PracticeAreaUpdateRequest
from clio-cli.models.practice_area_update_request_data import PracticeAreaUpdateRequestData
from clio-cli.models.related_contacts import RelatedContacts
from clio-cli.models.related_contacts_base import RelatedContactsBase
from clio-cli.models.related_contacts_list import RelatedContactsList
from clio-cli.models.relationship import Relationship
from clio-cli.models.relationship_base import RelationshipBase
from clio-cli.models.relationship_create_request import RelationshipCreateRequest
from clio-cli.models.relationship_create_request_data import RelationshipCreateRequestData
from clio-cli.models.relationship_create_request_data_matter import RelationshipCreateRequestDataMatter
from clio-cli.models.relationship_list import RelationshipList
from clio-cli.models.relationship_show import RelationshipShow
from clio-cli.models.reminder import Reminder
from clio-cli.models.reminder_base import ReminderBase
from clio-cli.models.reminder_create_request import ReminderCreateRequest
from clio-cli.models.reminder_create_request_data import ReminderCreateRequestData
from clio-cli.models.reminder_create_request_data_subject import ReminderCreateRequestDataSubject
from clio-cli.models.reminder_list import ReminderList
from clio-cli.models.reminder_show import ReminderShow
from clio-cli.models.reminder_template_base import ReminderTemplateBase
from clio-cli.models.reminder_update_request import ReminderUpdateRequest
from clio-cli.models.reminder_update_request_data import ReminderUpdateRequestData
from clio-cli.models.report import Report
from clio-cli.models.report_base import ReportBase
from clio-cli.models.report_create_request import ReportCreateRequest
from clio-cli.models.report_create_request_data import ReportCreateRequestData
from clio-cli.models.report_create_request_data_client import ReportCreateRequestDataClient
from clio-cli.models.report_create_request_data_matter import ReportCreateRequestDataMatter
from clio-cli.models.report_create_request_data_originating_attorney import ReportCreateRequestDataOriginatingAttorney
from clio-cli.models.report_create_request_data_practice_area import ReportCreateRequestDataPracticeArea
from clio-cli.models.report_list import ReportList
from clio-cli.models.report_preset import ReportPreset
from clio-cli.models.report_preset_base import ReportPresetBase
from clio-cli.models.report_preset_create_request import ReportPresetCreateRequest
from clio-cli.models.report_preset_create_request_data import ReportPresetCreateRequestData
from clio-cli.models.report_preset_list import ReportPresetList
from clio-cli.models.report_preset_show import ReportPresetShow
from clio-cli.models.report_preset_update_request import ReportPresetUpdateRequest
from clio-cli.models.report_preset_update_request_data import ReportPresetUpdateRequestData
from clio-cli.models.report_schedule import ReportSchedule
from clio-cli.models.report_schedule_base import ReportScheduleBase
from clio-cli.models.report_schedule_create_request import ReportScheduleCreateRequest
from clio-cli.models.report_schedule_create_request_data import ReportScheduleCreateRequestData
from clio-cli.models.report_schedule_list import ReportScheduleList
from clio-cli.models.report_schedule_show import ReportScheduleShow
from clio-cli.models.report_schedule_update_request import ReportScheduleUpdateRequest
from clio-cli.models.report_schedule_update_request_data import ReportScheduleUpdateRequestData
from clio-cli.models.report_show import ReportShow
from clio-cli.models.service_type import ServiceType
from clio-cli.models.service_type_base import ServiceTypeBase
from clio-cli.models.service_type_list import ServiceTypeList
from clio-cli.models.service_type_show import ServiceTypeShow
from clio-cli.models.task import Task
from clio-cli.models.task_base import TaskBase
from clio-cli.models.task_create_request import TaskCreateRequest
from clio-cli.models.task_create_request_data import TaskCreateRequestData
from clio-cli.models.task_create_request_data_assignee import TaskCreateRequestDataAssignee
from clio-cli.models.task_create_request_data_matter import TaskCreateRequestDataMatter
from clio-cli.models.task_create_request_data_task_type import TaskCreateRequestDataTaskType
from clio-cli.models.task_list import TaskList
from clio-cli.models.task_show import TaskShow
from clio-cli.models.task_template import TaskTemplate
from clio-cli.models.task_template_base import TaskTemplateBase
from clio-cli.models.task_template_create_request import TaskTemplateCreateRequest
from clio-cli.models.task_template_create_request_data import TaskTemplateCreateRequestData
from clio-cli.models.task_template_create_request_data_cascading_source import TaskTemplateCreateRequestDataCascadingSource
from clio-cli.models.task_template_create_request_data_reminder_templates_inner import TaskTemplateCreateRequestDataReminderTemplatesInner
from clio-cli.models.task_template_create_request_data_task_template_list import TaskTemplateCreateRequestDataTaskTemplateList
from clio-cli.models.task_template_list import TaskTemplateList
from clio-cli.models.task_template_list_base import TaskTemplateListBase
from clio-cli.models.task_template_list_copy_request import TaskTemplateListCopyRequest
from clio-cli.models.task_template_list_copy_request_data import TaskTemplateListCopyRequestData
from clio-cli.models.task_template_list_copy_request_data_practice_area import TaskTemplateListCopyRequestDataPracticeArea
from clio-cli.models.task_template_list_create_request import TaskTemplateListCreateRequest
from clio-cli.models.task_template_list_create_request_data import TaskTemplateListCreateRequestData
from clio-cli.models.task_template_list_create_request_data_practice_area import TaskTemplateListCreateRequestDataPracticeArea
from clio-cli.models.task_template_list_instace_base import TaskTemplateListInstaceBase
from clio-cli.models.task_template_list_list import TaskTemplateListList
from clio-cli.models.task_template_list_show import TaskTemplateListShow
from clio-cli.models.task_template_list_update_request import TaskTemplateListUpdateRequest
from clio-cli.models.task_template_list_update_request_data import TaskTemplateListUpdateRequestData
from clio-cli.models.task_template_show import TaskTemplateShow
from clio-cli.models.task_template_update_request import TaskTemplateUpdateRequest
from clio-cli.models.task_template_update_request_data import TaskTemplateUpdateRequestData
from clio-cli.models.task_template_update_request_data_reminder_templates_inner import TaskTemplateUpdateRequestDataReminderTemplatesInner
from clio-cli.models.task_type import TaskType
from clio-cli.models.task_type_base import TaskTypeBase
from clio-cli.models.task_type_create_request import TaskTypeCreateRequest
from clio-cli.models.task_type_create_request_data import TaskTypeCreateRequestData
from clio-cli.models.task_type_list import TaskTypeList
from clio-cli.models.task_type_show import TaskTypeShow
from clio-cli.models.task_type_update_request import TaskTypeUpdateRequest
from clio-cli.models.task_type_update_request_data import TaskTypeUpdateRequestData
from clio-cli.models.task_update_request import TaskUpdateRequest
from clio-cli.models.task_update_request_data import TaskUpdateRequestData
from clio-cli.models.task_update_request_data_assignee import TaskUpdateRequestDataAssignee
from clio-cli.models.text_snippet import TextSnippet
from clio-cli.models.text_snippet_base import TextSnippetBase
from clio-cli.models.text_snippet_create_request import TextSnippetCreateRequest
from clio-cli.models.text_snippet_create_request_data import TextSnippetCreateRequestData
from clio-cli.models.text_snippet_list import TextSnippetList
from clio-cli.models.text_snippet_show import TextSnippetShow
from clio-cli.models.text_snippet_update_request import TextSnippetUpdateRequest
from clio-cli.models.text_snippet_update_request_data import TextSnippetUpdateRequestData
from clio-cli.models.timer import Timer
from clio-cli.models.timer_base import TimerBase
from clio-cli.models.timer_create_request import TimerCreateRequest
from clio-cli.models.timer_create_request_data import TimerCreateRequestData
from clio-cli.models.timer_create_request_data_activity import TimerCreateRequestDataActivity
from clio-cli.models.timer_show import TimerShow
from clio-cli.models.trust_line_item import TrustLineItem
from clio-cli.models.trust_line_item_base import TrustLineItemBase
from clio-cli.models.trust_line_item_list import TrustLineItemList
from clio-cli.models.trust_line_item_show import TrustLineItemShow
from clio-cli.models.trust_line_item_update_request import TrustLineItemUpdateRequest
from clio-cli.models.trust_line_item_update_request_data import TrustLineItemUpdateRequestData
from clio-cli.models.trust_request import TrustRequest
from clio-cli.models.trust_request_base import TrustRequestBase
from clio-cli.models.trust_request_create_request import TrustRequestCreateRequest
from clio-cli.models.trust_request_create_request_data import TrustRequestCreateRequestData
from clio-cli.models.trust_request_create_request_data_matter_inner import TrustRequestCreateRequestDataMatterInner
from clio-cli.models.trust_request_show import TrustRequestShow
from clio-cli.models.user import User
from clio-cli.models.user_base import UserBase
from clio-cli.models.user_list import UserList
from clio-cli.models.user_show import UserShow
from clio-cli.models.utbms_code import UtbmsCode
from clio-cli.models.utbms_code_base import UtbmsCodeBase
from clio-cli.models.utbms_code_list import UtbmsCodeList
from clio-cli.models.utbms_code_show import UtbmsCodeShow
from clio-cli.models.utbms_set import UtbmsSet
from clio-cli.models.utbms_set_base import UtbmsSetBase
from clio-cli.models.utbms_set_list import UtbmsSetList
from clio-cli.models.web_site_base import WebSiteBase
from clio-cli.models.webhook import Webhook
from clio-cli.models.webhook_base import WebhookBase
from clio-cli.models.webhook_create_request import WebhookCreateRequest
from clio-cli.models.webhook_create_request_data import WebhookCreateRequestData
from clio-cli.models.webhook_list import WebhookList
from clio-cli.models.webhook_show import WebhookShow
from clio-cli.models.webhook_update_request import WebhookUpdateRequest
from clio-cli.models.webhook_update_request_data import WebhookUpdateRequestData
