# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError

from typing_extensions import Annotated
from datetime import date, datetime

from pydantic import Field, StrictBool, StrictInt, StrictStr

from typing import Optional

from clio-cli.models.calendar_entry_create_request import CalendarEntryCreateRequest
from clio-cli.models.calendar_entry_list import CalendarEntryList
from clio-cli.models.calendar_entry_show import CalendarEntryShow
from clio-cli.models.calendar_entry_update_request import CalendarEntryUpdateRequest

from clio-cli.api_client import ApiClient
from clio-cli.api_response import ApiResponse
from clio-cli.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class CalendarEntriesApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def calendar_entry_create(self, x_api_version : Annotated[Optional[StrictStr], Field(description="The [API minor version](#section/Minor-Versions). Default: latest version.")] = None, fields : Annotated[Optional[StrictStr], Field(description="The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).")] = None, calendar_entry_create_request : Annotated[Optional[CalendarEntryCreateRequest], Field(description="Request Body for Calendar Entries")] = None, **kwargs) -> CalendarEntryShow:  # noqa: E501
        """Create a new CalendarEntry  # noqa: E501

        Outlines the parameters and data fields used when creating a new CalendarEntry  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.calendar_entry_create(x_api_version, fields, calendar_entry_create_request, async_req=True)
        >>> result = thread.get()

        :param x_api_version: The [API minor version](#section/Minor-Versions). Default: latest version.
        :type x_api_version: str
        :param fields: The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).
        :type fields: str
        :param calendar_entry_create_request: Request Body for Calendar Entries
        :type calendar_entry_create_request: CalendarEntryCreateRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CalendarEntryShow
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the calendar_entry_create_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.calendar_entry_create_with_http_info(x_api_version, fields, calendar_entry_create_request, **kwargs)  # noqa: E501

    @validate_arguments
    def calendar_entry_create_with_http_info(self, x_api_version : Annotated[Optional[StrictStr], Field(description="The [API minor version](#section/Minor-Versions). Default: latest version.")] = None, fields : Annotated[Optional[StrictStr], Field(description="The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).")] = None, calendar_entry_create_request : Annotated[Optional[CalendarEntryCreateRequest], Field(description="Request Body for Calendar Entries")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Create a new CalendarEntry  # noqa: E501

        Outlines the parameters and data fields used when creating a new CalendarEntry  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.calendar_entry_create_with_http_info(x_api_version, fields, calendar_entry_create_request, async_req=True)
        >>> result = thread.get()

        :param x_api_version: The [API minor version](#section/Minor-Versions). Default: latest version.
        :type x_api_version: str
        :param fields: The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).
        :type fields: str
        :param calendar_entry_create_request: Request Body for Calendar Entries
        :type calendar_entry_create_request: CalendarEntryCreateRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CalendarEntryShow, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'x_api_version',
            'fields',
            'calendar_entry_create_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method calendar_entry_create" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('fields') is not None:  # noqa: E501
            _query_params.append(('fields', _params['fields']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['x_api_version'] is not None:
            _header_params['X-API-VERSION'] = _params['x_api_version']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['calendar_entry_create_request'] is not None:
            _body_params = _params['calendar_entry_create_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json; charset=utf-8'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '201': "CalendarEntryShow",
            '400': "Error",
            '403': "Error",
            '404': "Error",
            '422': "Error",
            '401': "Error",
            '429': "Error",
        }

        return self.api_client.call_api(
            '/calendar_entries.json', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def calendar_entry_destroy(self, id : Annotated[StrictInt, Field(..., description="The unique identifier for the CalendarEntry.")], x_api_version : Annotated[Optional[StrictStr], Field(description="The [API minor version](#section/Minor-Versions). Default: latest version.")] = None, **kwargs) -> None:  # noqa: E501
        """Delete a single CalendarEntry  # noqa: E501

        Outlines the parameters, optional and required, used when deleting the record for a single CalendarEntry  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.calendar_entry_destroy(id, x_api_version, async_req=True)
        >>> result = thread.get()

        :param id: The unique identifier for the CalendarEntry. (required)
        :type id: int
        :param x_api_version: The [API minor version](#section/Minor-Versions). Default: latest version.
        :type x_api_version: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the calendar_entry_destroy_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.calendar_entry_destroy_with_http_info(id, x_api_version, **kwargs)  # noqa: E501

    @validate_arguments
    def calendar_entry_destroy_with_http_info(self, id : Annotated[StrictInt, Field(..., description="The unique identifier for the CalendarEntry.")], x_api_version : Annotated[Optional[StrictStr], Field(description="The [API minor version](#section/Minor-Versions). Default: latest version.")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Delete a single CalendarEntry  # noqa: E501

        Outlines the parameters, optional and required, used when deleting the record for a single CalendarEntry  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.calendar_entry_destroy_with_http_info(id, x_api_version, async_req=True)
        >>> result = thread.get()

        :param id: The unique identifier for the CalendarEntry. (required)
        :type id: int
        :param x_api_version: The [API minor version](#section/Minor-Versions). Default: latest version.
        :type x_api_version: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

        _params = locals()

        _all_params = [
            'id',
            'x_api_version'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method calendar_entry_destroy" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id'] is not None:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['x_api_version'] is not None:
            _header_params['X-API-VERSION'] = _params['x_api_version']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json; charset=utf-8'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {}

        return self.api_client.call_api(
            '/calendar_entries/{id}.json', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def calendar_entry_index(self, x_api_version : Annotated[Optional[StrictStr], Field(description="The [API minor version](#section/Minor-Versions). Default: latest version.")] = None, calendar_id : Annotated[Optional[StrictInt], Field(description="The unique identifier for a single Calendar. The keyword `null` is not valid for this field. The list will be filtered to include only the CalendarEntry records with the matching property.")] = None, created_since : Annotated[Optional[datetime], Field(description="Filter CalendarEntry records to those having the `created_at` field after a specific time. (Expects an ISO-8601 timestamp).")] = None, expanded : Annotated[Optional[StrictBool], Field(description="Returns a record for each occurrence of a recurring calendar event.  Non-recurring calendar events are unaffected and returned as separate records regardless of the expanded setting.")] = None, external_property_name : Annotated[Optional[StrictStr], Field(description="Filter records to only those with the given external property(s) name set.  e.g. `?external_property_name=Name` ")] = None, external_property_value : Annotated[Optional[StrictStr], Field(description="Filter records to only those with the given external property(s) value set. Requires external property name as well.  e.g. `?external_property_name=Name&external_property_value=Value` ")] = None, fields : Annotated[Optional[StrictStr], Field(description="The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).")] = None, var_from : Annotated[Optional[datetime], Field(description="Filter CalendarEntry records to those that end on or after the provided time (Expects an ISO-8601 timestamp).")] = None, has_court_rule : Annotated[Optional[StrictBool], Field(description="Allows matching court rule on calendar entry.")] = None, ids : Annotated[Optional[StrictInt], Field(description="Filter CalendarEntry records to those having the specified unique identifiers.")] = None, is_all_day : Annotated[Optional[StrictBool], Field(description="Filter CalendarEntry records to those that are marked as all day events.")] = None, limit : Annotated[Optional[StrictInt], Field(description="A limit on the number of CalendarEntry records to be returned. Limit can range between 1 and 200. Default: `200`.")] = None, matter_id : Annotated[Optional[StrictInt], Field(description="The unique identifier for a single Matter. Use the keyword `null` to match those without a CalendarEntry. The list will be filtered to include only the CalendarEntry records with the matching property.")] = None, owner_entries_across_all_users : Annotated[Optional[StrictBool], Field(description="Returns CalendarEntry records for all users related to a matter. Requires matter id.")] = None, page_token : Annotated[Optional[StrictStr], Field(description="A token specifying which page to return.")] = None, query : Annotated[Optional[StrictStr], Field(description="Allows matching search on calendar entry.")] = None, source : Annotated[Optional[StrictStr], Field(description="Filter CalendarEntry records to those having a specific calendar visibility source (mobile, web).")] = None, to : Annotated[Optional[datetime], Field(description="Filter CalendarEntry records to those that begin on or before the provided time (Expects an ISO-8601 timestamp).")] = None, updated_since : Annotated[Optional[datetime], Field(description="Filter CalendarEntry records to those having the `updated_at` field after a specific time. (Expects an ISO-8601 timestamp).")] = None, visible : Annotated[Optional[StrictBool], Field(description="Filter CalendarEntry records to those that are visible.")] = None, **kwargs) -> CalendarEntryList:  # noqa: E501
        """Return the data for all CalendarEntries  # noqa: E501

        Outlines the parameters, optional and required, used when requesting the data for all CalendarEntries  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.calendar_entry_index(x_api_version, calendar_id, created_since, expanded, external_property_name, external_property_value, fields, var_from, has_court_rule, ids, is_all_day, limit, matter_id, owner_entries_across_all_users, page_token, query, source, to, updated_since, visible, async_req=True)
        >>> result = thread.get()

        :param x_api_version: The [API minor version](#section/Minor-Versions). Default: latest version.
        :type x_api_version: str
        :param calendar_id: The unique identifier for a single Calendar. The keyword `null` is not valid for this field. The list will be filtered to include only the CalendarEntry records with the matching property.
        :type calendar_id: int
        :param created_since: Filter CalendarEntry records to those having the `created_at` field after a specific time. (Expects an ISO-8601 timestamp).
        :type created_since: datetime
        :param expanded: Returns a record for each occurrence of a recurring calendar event.  Non-recurring calendar events are unaffected and returned as separate records regardless of the expanded setting.
        :type expanded: bool
        :param external_property_name: Filter records to only those with the given external property(s) name set.  e.g. `?external_property_name=Name` 
        :type external_property_name: str
        :param external_property_value: Filter records to only those with the given external property(s) value set. Requires external property name as well.  e.g. `?external_property_name=Name&external_property_value=Value` 
        :type external_property_value: str
        :param fields: The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).
        :type fields: str
        :param var_from: Filter CalendarEntry records to those that end on or after the provided time (Expects an ISO-8601 timestamp).
        :type var_from: datetime
        :param has_court_rule: Allows matching court rule on calendar entry.
        :type has_court_rule: bool
        :param ids: Filter CalendarEntry records to those having the specified unique identifiers.
        :type ids: int
        :param is_all_day: Filter CalendarEntry records to those that are marked as all day events.
        :type is_all_day: bool
        :param limit: A limit on the number of CalendarEntry records to be returned. Limit can range between 1 and 200. Default: `200`.
        :type limit: int
        :param matter_id: The unique identifier for a single Matter. Use the keyword `null` to match those without a CalendarEntry. The list will be filtered to include only the CalendarEntry records with the matching property.
        :type matter_id: int
        :param owner_entries_across_all_users: Returns CalendarEntry records for all users related to a matter. Requires matter id.
        :type owner_entries_across_all_users: bool
        :param page_token: A token specifying which page to return.
        :type page_token: str
        :param query: Allows matching search on calendar entry.
        :type query: str
        :param source: Filter CalendarEntry records to those having a specific calendar visibility source (mobile, web).
        :type source: str
        :param to: Filter CalendarEntry records to those that begin on or before the provided time (Expects an ISO-8601 timestamp).
        :type to: datetime
        :param updated_since: Filter CalendarEntry records to those having the `updated_at` field after a specific time. (Expects an ISO-8601 timestamp).
        :type updated_since: datetime
        :param visible: Filter CalendarEntry records to those that are visible.
        :type visible: bool
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CalendarEntryList
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the calendar_entry_index_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.calendar_entry_index_with_http_info(x_api_version, calendar_id, created_since, expanded, external_property_name, external_property_value, fields, var_from, has_court_rule, ids, is_all_day, limit, matter_id, owner_entries_across_all_users, page_token, query, source, to, updated_since, visible, **kwargs)  # noqa: E501

    @validate_arguments
    def calendar_entry_index_with_http_info(self, x_api_version : Annotated[Optional[StrictStr], Field(description="The [API minor version](#section/Minor-Versions). Default: latest version.")] = None, calendar_id : Annotated[Optional[StrictInt], Field(description="The unique identifier for a single Calendar. The keyword `null` is not valid for this field. The list will be filtered to include only the CalendarEntry records with the matching property.")] = None, created_since : Annotated[Optional[datetime], Field(description="Filter CalendarEntry records to those having the `created_at` field after a specific time. (Expects an ISO-8601 timestamp).")] = None, expanded : Annotated[Optional[StrictBool], Field(description="Returns a record for each occurrence of a recurring calendar event.  Non-recurring calendar events are unaffected and returned as separate records regardless of the expanded setting.")] = None, external_property_name : Annotated[Optional[StrictStr], Field(description="Filter records to only those with the given external property(s) name set.  e.g. `?external_property_name=Name` ")] = None, external_property_value : Annotated[Optional[StrictStr], Field(description="Filter records to only those with the given external property(s) value set. Requires external property name as well.  e.g. `?external_property_name=Name&external_property_value=Value` ")] = None, fields : Annotated[Optional[StrictStr], Field(description="The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).")] = None, var_from : Annotated[Optional[datetime], Field(description="Filter CalendarEntry records to those that end on or after the provided time (Expects an ISO-8601 timestamp).")] = None, has_court_rule : Annotated[Optional[StrictBool], Field(description="Allows matching court rule on calendar entry.")] = None, ids : Annotated[Optional[StrictInt], Field(description="Filter CalendarEntry records to those having the specified unique identifiers.")] = None, is_all_day : Annotated[Optional[StrictBool], Field(description="Filter CalendarEntry records to those that are marked as all day events.")] = None, limit : Annotated[Optional[StrictInt], Field(description="A limit on the number of CalendarEntry records to be returned. Limit can range between 1 and 200. Default: `200`.")] = None, matter_id : Annotated[Optional[StrictInt], Field(description="The unique identifier for a single Matter. Use the keyword `null` to match those without a CalendarEntry. The list will be filtered to include only the CalendarEntry records with the matching property.")] = None, owner_entries_across_all_users : Annotated[Optional[StrictBool], Field(description="Returns CalendarEntry records for all users related to a matter. Requires matter id.")] = None, page_token : Annotated[Optional[StrictStr], Field(description="A token specifying which page to return.")] = None, query : Annotated[Optional[StrictStr], Field(description="Allows matching search on calendar entry.")] = None, source : Annotated[Optional[StrictStr], Field(description="Filter CalendarEntry records to those having a specific calendar visibility source (mobile, web).")] = None, to : Annotated[Optional[datetime], Field(description="Filter CalendarEntry records to those that begin on or before the provided time (Expects an ISO-8601 timestamp).")] = None, updated_since : Annotated[Optional[datetime], Field(description="Filter CalendarEntry records to those having the `updated_at` field after a specific time. (Expects an ISO-8601 timestamp).")] = None, visible : Annotated[Optional[StrictBool], Field(description="Filter CalendarEntry records to those that are visible.")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Return the data for all CalendarEntries  # noqa: E501

        Outlines the parameters, optional and required, used when requesting the data for all CalendarEntries  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.calendar_entry_index_with_http_info(x_api_version, calendar_id, created_since, expanded, external_property_name, external_property_value, fields, var_from, has_court_rule, ids, is_all_day, limit, matter_id, owner_entries_across_all_users, page_token, query, source, to, updated_since, visible, async_req=True)
        >>> result = thread.get()

        :param x_api_version: The [API minor version](#section/Minor-Versions). Default: latest version.
        :type x_api_version: str
        :param calendar_id: The unique identifier for a single Calendar. The keyword `null` is not valid for this field. The list will be filtered to include only the CalendarEntry records with the matching property.
        :type calendar_id: int
        :param created_since: Filter CalendarEntry records to those having the `created_at` field after a specific time. (Expects an ISO-8601 timestamp).
        :type created_since: datetime
        :param expanded: Returns a record for each occurrence of a recurring calendar event.  Non-recurring calendar events are unaffected and returned as separate records regardless of the expanded setting.
        :type expanded: bool
        :param external_property_name: Filter records to only those with the given external property(s) name set.  e.g. `?external_property_name=Name` 
        :type external_property_name: str
        :param external_property_value: Filter records to only those with the given external property(s) value set. Requires external property name as well.  e.g. `?external_property_name=Name&external_property_value=Value` 
        :type external_property_value: str
        :param fields: The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).
        :type fields: str
        :param var_from: Filter CalendarEntry records to those that end on or after the provided time (Expects an ISO-8601 timestamp).
        :type var_from: datetime
        :param has_court_rule: Allows matching court rule on calendar entry.
        :type has_court_rule: bool
        :param ids: Filter CalendarEntry records to those having the specified unique identifiers.
        :type ids: int
        :param is_all_day: Filter CalendarEntry records to those that are marked as all day events.
        :type is_all_day: bool
        :param limit: A limit on the number of CalendarEntry records to be returned. Limit can range between 1 and 200. Default: `200`.
        :type limit: int
        :param matter_id: The unique identifier for a single Matter. Use the keyword `null` to match those without a CalendarEntry. The list will be filtered to include only the CalendarEntry records with the matching property.
        :type matter_id: int
        :param owner_entries_across_all_users: Returns CalendarEntry records for all users related to a matter. Requires matter id.
        :type owner_entries_across_all_users: bool
        :param page_token: A token specifying which page to return.
        :type page_token: str
        :param query: Allows matching search on calendar entry.
        :type query: str
        :param source: Filter CalendarEntry records to those having a specific calendar visibility source (mobile, web).
        :type source: str
        :param to: Filter CalendarEntry records to those that begin on or before the provided time (Expects an ISO-8601 timestamp).
        :type to: datetime
        :param updated_since: Filter CalendarEntry records to those having the `updated_at` field after a specific time. (Expects an ISO-8601 timestamp).
        :type updated_since: datetime
        :param visible: Filter CalendarEntry records to those that are visible.
        :type visible: bool
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CalendarEntryList, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'x_api_version',
            'calendar_id',
            'created_since',
            'expanded',
            'external_property_name',
            'external_property_value',
            'fields',
            'var_from',
            'has_court_rule',
            'ids',
            'is_all_day',
            'limit',
            'matter_id',
            'owner_entries_across_all_users',
            'page_token',
            'query',
            'source',
            'to',
            'updated_since',
            'visible'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method calendar_entry_index" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('calendar_id') is not None:  # noqa: E501
            _query_params.append(('calendar_id', _params['calendar_id']))

        if _params.get('created_since') is not None:  # noqa: E501
            if isinstance(_params['created_since'], datetime):
                _query_params.append(('created_since', _params['created_since'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('created_since', _params['created_since']))

        if _params.get('expanded') is not None:  # noqa: E501
            _query_params.append(('expanded', _params['expanded']))

        if _params.get('external_property_name') is not None:  # noqa: E501
            _query_params.append(('external_property_name', _params['external_property_name']))

        if _params.get('external_property_value') is not None:  # noqa: E501
            _query_params.append(('external_property_value', _params['external_property_value']))

        if _params.get('fields') is not None:  # noqa: E501
            _query_params.append(('fields', _params['fields']))

        if _params.get('var_from') is not None:  # noqa: E501
            if isinstance(_params['var_from'], datetime):
                _query_params.append(('from', _params['var_from'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('from', _params['var_from']))

        if _params.get('has_court_rule') is not None:  # noqa: E501
            _query_params.append(('has_court_rule', _params['has_court_rule']))

        if _params.get('ids') is not None:  # noqa: E501
            _query_params.append(('ids[]', _params['ids']))

        if _params.get('is_all_day') is not None:  # noqa: E501
            _query_params.append(('is_all_day', _params['is_all_day']))

        if _params.get('limit') is not None:  # noqa: E501
            _query_params.append(('limit', _params['limit']))

        if _params.get('matter_id') is not None:  # noqa: E501
            _query_params.append(('matter_id', _params['matter_id']))

        if _params.get('owner_entries_across_all_users') is not None:  # noqa: E501
            _query_params.append(('owner_entries_across_all_users', _params['owner_entries_across_all_users']))

        if _params.get('page_token') is not None:  # noqa: E501
            _query_params.append(('page_token', _params['page_token']))

        if _params.get('query') is not None:  # noqa: E501
            _query_params.append(('query', _params['query']))

        if _params.get('source') is not None:  # noqa: E501
            _query_params.append(('source', _params['source']))

        if _params.get('to') is not None:  # noqa: E501
            if isinstance(_params['to'], datetime):
                _query_params.append(('to', _params['to'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('to', _params['to']))

        if _params.get('updated_since') is not None:  # noqa: E501
            if isinstance(_params['updated_since'], datetime):
                _query_params.append(('updated_since', _params['updated_since'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('updated_since', _params['updated_since']))

        if _params.get('visible') is not None:  # noqa: E501
            _query_params.append(('visible', _params['visible']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['x_api_version'] is not None:
            _header_params['X-API-VERSION'] = _params['x_api_version']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json; charset=utf-8'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "CalendarEntryList",
            '400': "Error",
            '401': "Error",
            '403': "Error",
            '429': "Error",
        }

        return self.api_client.call_api(
            '/calendar_entries.json', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def calendar_entry_show(self, id : Annotated[StrictInt, Field(..., description="The unique identifier for the CalendarEntry.")], if_modified_since : Annotated[Optional[date], Field(description="The server will send the requested resource with a 200 status, but only if it has been modified after the given date. (Expects an RFC 2822 timestamp).")] = None, if_none_match : Annotated[Optional[StrictStr], Field(description="The server will send the requested resource with a 200 status, but only if the existing resource's [ETag](#section/ETags) doesn't match any of the values listed.")] = None, x_api_version : Annotated[Optional[StrictStr], Field(description="The [API minor version](#section/Minor-Versions). Default: latest version.")] = None, fields : Annotated[Optional[StrictStr], Field(description="The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).")] = None, **kwargs) -> CalendarEntryShow:  # noqa: E501
        """Return the data for a single CalendarEntry  # noqa: E501

        Outlines the parameters, optional and required, used when requesting the data for a single CalendarEntry  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.calendar_entry_show(id, if_modified_since, if_none_match, x_api_version, fields, async_req=True)
        >>> result = thread.get()

        :param id: The unique identifier for the CalendarEntry. (required)
        :type id: int
        :param if_modified_since: The server will send the requested resource with a 200 status, but only if it has been modified after the given date. (Expects an RFC 2822 timestamp).
        :type if_modified_since: date
        :param if_none_match: The server will send the requested resource with a 200 status, but only if the existing resource's [ETag](#section/ETags) doesn't match any of the values listed.
        :type if_none_match: str
        :param x_api_version: The [API minor version](#section/Minor-Versions). Default: latest version.
        :type x_api_version: str
        :param fields: The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).
        :type fields: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CalendarEntryShow
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the calendar_entry_show_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.calendar_entry_show_with_http_info(id, if_modified_since, if_none_match, x_api_version, fields, **kwargs)  # noqa: E501

    @validate_arguments
    def calendar_entry_show_with_http_info(self, id : Annotated[StrictInt, Field(..., description="The unique identifier for the CalendarEntry.")], if_modified_since : Annotated[Optional[date], Field(description="The server will send the requested resource with a 200 status, but only if it has been modified after the given date. (Expects an RFC 2822 timestamp).")] = None, if_none_match : Annotated[Optional[StrictStr], Field(description="The server will send the requested resource with a 200 status, but only if the existing resource's [ETag](#section/ETags) doesn't match any of the values listed.")] = None, x_api_version : Annotated[Optional[StrictStr], Field(description="The [API minor version](#section/Minor-Versions). Default: latest version.")] = None, fields : Annotated[Optional[StrictStr], Field(description="The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Return the data for a single CalendarEntry  # noqa: E501

        Outlines the parameters, optional and required, used when requesting the data for a single CalendarEntry  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.calendar_entry_show_with_http_info(id, if_modified_since, if_none_match, x_api_version, fields, async_req=True)
        >>> result = thread.get()

        :param id: The unique identifier for the CalendarEntry. (required)
        :type id: int
        :param if_modified_since: The server will send the requested resource with a 200 status, but only if it has been modified after the given date. (Expects an RFC 2822 timestamp).
        :type if_modified_since: date
        :param if_none_match: The server will send the requested resource with a 200 status, but only if the existing resource's [ETag](#section/ETags) doesn't match any of the values listed.
        :type if_none_match: str
        :param x_api_version: The [API minor version](#section/Minor-Versions). Default: latest version.
        :type x_api_version: str
        :param fields: The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).
        :type fields: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CalendarEntryShow, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'if_modified_since',
            'if_none_match',
            'x_api_version',
            'fields'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method calendar_entry_show" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id'] is not None:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        if _params.get('fields') is not None:  # noqa: E501
            _query_params.append(('fields', _params['fields']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['if_modified_since'] is not None:
            _header_params['IF-MODIFIED-SINCE'] = _params['if_modified_since']

        if _params['if_none_match'] is not None:
            _header_params['IF-NONE-MATCH'] = _params['if_none_match']

        if _params['x_api_version'] is not None:
            _header_params['X-API-VERSION'] = _params['x_api_version']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json; charset=utf-8'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "CalendarEntryShow",
            '400': "Error",
            '403': "Error",
            '404': "Error",
            '401': "Error",
            '429': "Error",
            '304': None,
        }

        return self.api_client.call_api(
            '/calendar_entries/{id}.json', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def calendar_entry_update(self, id : Annotated[StrictInt, Field(..., description="The unique identifier for the CalendarEntry.")], if_match : Annotated[Optional[StrictStr], Field(description="The server will update the requested resource and send back a 200 status, but only if value in the header matches the existing resource's [ETag](#section/ETags).")] = None, x_api_version : Annotated[Optional[StrictStr], Field(description="The [API minor version](#section/Minor-Versions). Default: latest version.")] = None, fields : Annotated[Optional[StrictStr], Field(description="The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).")] = None, calendar_entry_update_request : Annotated[Optional[CalendarEntryUpdateRequest], Field(description="Request Body for Calendar Entries")] = None, **kwargs) -> CalendarEntryShow:  # noqa: E501
        """Update a single CalendarEntry  # noqa: E501

        Outlines the parameters and data fields used when updating a single CalendarEntry  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.calendar_entry_update(id, if_match, x_api_version, fields, calendar_entry_update_request, async_req=True)
        >>> result = thread.get()

        :param id: The unique identifier for the CalendarEntry. (required)
        :type id: int
        :param if_match: The server will update the requested resource and send back a 200 status, but only if value in the header matches the existing resource's [ETag](#section/ETags).
        :type if_match: str
        :param x_api_version: The [API minor version](#section/Minor-Versions). Default: latest version.
        :type x_api_version: str
        :param fields: The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).
        :type fields: str
        :param calendar_entry_update_request: Request Body for Calendar Entries
        :type calendar_entry_update_request: CalendarEntryUpdateRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CalendarEntryShow
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the calendar_entry_update_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.calendar_entry_update_with_http_info(id, if_match, x_api_version, fields, calendar_entry_update_request, **kwargs)  # noqa: E501

    @validate_arguments
    def calendar_entry_update_with_http_info(self, id : Annotated[StrictInt, Field(..., description="The unique identifier for the CalendarEntry.")], if_match : Annotated[Optional[StrictStr], Field(description="The server will update the requested resource and send back a 200 status, but only if value in the header matches the existing resource's [ETag](#section/ETags).")] = None, x_api_version : Annotated[Optional[StrictStr], Field(description="The [API minor version](#section/Minor-Versions). Default: latest version.")] = None, fields : Annotated[Optional[StrictStr], Field(description="The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).")] = None, calendar_entry_update_request : Annotated[Optional[CalendarEntryUpdateRequest], Field(description="Request Body for Calendar Entries")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Update a single CalendarEntry  # noqa: E501

        Outlines the parameters and data fields used when updating a single CalendarEntry  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.calendar_entry_update_with_http_info(id, if_match, x_api_version, fields, calendar_entry_update_request, async_req=True)
        >>> result = thread.get()

        :param id: The unique identifier for the CalendarEntry. (required)
        :type id: int
        :param if_match: The server will update the requested resource and send back a 200 status, but only if value in the header matches the existing resource's [ETag](#section/ETags).
        :type if_match: str
        :param x_api_version: The [API minor version](#section/Minor-Versions). Default: latest version.
        :type x_api_version: str
        :param fields: The fields to be returned. See response samples for what fields are available. For more information see the [fields section](#section/Fields).
        :type fields: str
        :param calendar_entry_update_request: Request Body for Calendar Entries
        :type calendar_entry_update_request: CalendarEntryUpdateRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CalendarEntryShow, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'if_match',
            'x_api_version',
            'fields',
            'calendar_entry_update_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method calendar_entry_update" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id'] is not None:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        if _params.get('fields') is not None:  # noqa: E501
            _query_params.append(('fields', _params['fields']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['if_match'] is not None:
            _header_params['IF-MATCH'] = _params['if_match']

        if _params['x_api_version'] is not None:
            _header_params['X-API-VERSION'] = _params['x_api_version']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['calendar_entry_update_request'] is not None:
            _body_params = _params['calendar_entry_update_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json; charset=utf-8'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "CalendarEntryShow",
            '400': "Error",
            '403': "Error",
            '404': "Error",
            '422': "Error",
            '401': "Error",
            '429': "Error",
            '412': "Error",
        }

        return self.api_client.call_api(
            '/calendar_entries/{id}.json', 'PATCH',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
