# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date, datetime
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from clio-cli.models.allocation_base import AllocationBase
from clio-cli.models.bank_account_base import BankAccountBase
from clio-cli.models.bill_base import BillBase
from clio-cli.models.contact_base import ContactBase
from clio-cli.models.matter_base import MatterBase

class BankTransaction(BaseModel):
    """
    BankTransaction
    """
    id: Optional[StrictInt] = Field(default=None, description="Unique identifier for the *BankTransaction*")
    type: Optional[StrictStr] = Field(default=None, description="The type of the *BankTransaction*")
    etag: Optional[StrictStr] = Field(default=None, description="ETag for the *BankTransaction*")
    created_at: Optional[datetime] = Field(default=None, description="The time the *BankTransaction* was created (as a ISO-8601 timestamp)")
    updated_at: Optional[datetime] = Field(default=None, description="The time the *BankTransaction* was last updated (as a ISO-8601 timestamp)")
    bank_account_id: Optional[StrictInt] = Field(default=None, description="The associated bank account.")
    source: Optional[StrictStr] = Field(default=None, description="Where the transaction came from.")
    confirmation: Optional[StrictStr] = Field(default=None, description="The reference code for the transaction.")
    var_date: Optional[date] = Field(default=None, alias="date", description="The date of the transaction.")
    amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The amount of the transaction.")
    currency: Optional[StrictStr] = Field(default=None, description="The currency of the transaction.")
    description: Optional[StrictStr] = Field(default=None, description="The description of the transaction.")
    exchange_rate: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The exchange rate of the transaction.")
    transaction_type: Optional[StrictStr] = Field(default=None, description="What kind of transaction.")
    funds_in: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The amount of funds received in this transaction.")
    funds_out: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The amount of funds withdrawn in this transaction.")
    clio_payments_transaction: Optional[StrictBool] = Field(default=None, description="Whether the transaction was created through online payments.")
    current_account_balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The current account balance.")
    read_only_confirmation: Optional[StrictBool] = Field(default=None, description="Whether the transaction's reference code is read-only.")
    client: Optional[ContactBase] = None
    matter: Optional[MatterBase] = None
    bank_account: Optional[BankAccountBase] = None
    bill: Optional[BillBase] = None
    allocation: Optional[AllocationBase] = None
    __properties = ["id", "type", "etag", "created_at", "updated_at", "bank_account_id", "source", "confirmation", "date", "amount", "currency", "description", "exchange_rate", "transaction_type", "funds_in", "funds_out", "clio_payments_transaction", "current_account_balance", "read_only_confirmation", "client", "matter", "bank_account", "bill", "allocation"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BankTransaction:
        """Create an instance of BankTransaction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of client
        if self.client:
            _dict['client'] = self.client.to_dict()
        # override the default output from pydantic by calling `to_dict()` of matter
        if self.matter:
            _dict['matter'] = self.matter.to_dict()
        # override the default output from pydantic by calling `to_dict()` of bank_account
        if self.bank_account:
            _dict['bank_account'] = self.bank_account.to_dict()
        # override the default output from pydantic by calling `to_dict()` of bill
        if self.bill:
            _dict['bill'] = self.bill.to_dict()
        # override the default output from pydantic by calling `to_dict()` of allocation
        if self.allocation:
            _dict['allocation'] = self.allocation.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BankTransaction:
        """Create an instance of BankTransaction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BankTransaction.parse_obj(obj)

        _obj = BankTransaction.parse_obj({
            "id": obj.get("id"),
            "type": obj.get("type"),
            "etag": obj.get("etag"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "bank_account_id": obj.get("bank_account_id"),
            "source": obj.get("source"),
            "confirmation": obj.get("confirmation"),
            "var_date": obj.get("date"),
            "amount": obj.get("amount"),
            "currency": obj.get("currency"),
            "description": obj.get("description"),
            "exchange_rate": obj.get("exchange_rate"),
            "transaction_type": obj.get("transaction_type"),
            "funds_in": obj.get("funds_in"),
            "funds_out": obj.get("funds_out"),
            "clio_payments_transaction": obj.get("clio_payments_transaction"),
            "current_account_balance": obj.get("current_account_balance"),
            "read_only_confirmation": obj.get("read_only_confirmation"),
            "client": ContactBase.from_dict(obj.get("client")) if obj.get("client") is not None else None,
            "matter": MatterBase.from_dict(obj.get("matter")) if obj.get("matter") is not None else None,
            "bank_account": BankAccountBase.from_dict(obj.get("bank_account")) if obj.get("bank_account") is not None else None,
            "bill": BillBase.from_dict(obj.get("bill")) if obj.get("bill") is not None else None,
            "allocation": AllocationBase.from_dict(obj.get("allocation")) if obj.get("allocation") is not None else None
        })
        return _obj


