# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date, datetime
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr, validator

class BillBase(BaseModel):
    """
    BillBase
    """
    id: Optional[StrictInt] = Field(default=None, description="Unique identifier for the *Bill*")
    etag: Optional[StrictStr] = Field(default=None, description="ETag for the *Bill*")
    number: Optional[StrictStr] = Field(default=None, description="The *Bill* identifier (not necessarily numeric)'")
    issued_at: Optional[date] = Field(default=None, description="The time the *Bill* was issued (as a ISO-8601 date)")
    created_at: Optional[datetime] = Field(default=None, description="The time the *Bill* was created (as a ISO-8601 timestamp)")
    due_at: Optional[date] = Field(default=None, description="The date the *Bill* is due (as a ISO-8601 date)")
    tax_rate: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The tax rate to the *Bill*")
    secondary_tax_rate: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="A secondary tax rate applied to the *Bill*")
    updated_at: Optional[datetime] = Field(default=None, description="The time the *Bill* was last updated (as a ISO-8601 timestamp)")
    subject: Optional[StrictStr] = Field(default=None, description="The subject of the *Bill*")
    purchase_order: Optional[StrictStr] = Field(default=None, description="The purchase order of the *Bill*")
    type: Optional[StrictStr] = Field(default=None, description="The type of the *Bill*")
    memo: Optional[StrictStr] = Field(default=None, description="A memo for the *Bill*")
    start_at: Optional[date] = Field(default=None, description="The time the billing period starts (as a ISO-8601 date)")
    end_at: Optional[date] = Field(default=None, description="The time the billing period ends (as a ISO-8601 date)")
    balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The outstanding balance of the *Bill*")
    state: Optional[StrictStr] = Field(default=None, description="The billing state the *Bill* is in")
    kind: Optional[StrictStr] = Field(default=None, description="The kind of the *Bill*")
    total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The total with interest of the *Bill*")
    paid: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The total amount paid for the *Bill*")
    paid_at: Optional[datetime] = Field(default=None, description="The date of the last payment on the *Bill*")
    pending: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The amount of pending credit card payments on the *Bill*")
    due: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The total amount of the *Bill* with interest and less discounts")
    discount_services_only: Optional[StrictStr] = Field(default=None, description="The selected discount is applied to services only.")
    can_update: Optional[StrictBool] = Field(default=None, description="This value indicates if your *Bill*'s line items and information can be updated.")
    credits_issued: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The total credits issued for the *Bill*")
    shared: Optional[StrictBool] = Field(default=None, description="Whether the *Bill* is a shared")
    last_sent_at: Optional[datetime] = Field(default=None, description="The last time the *Bill* was sent (as a ISO-8601 date)")
    services_secondary_tax: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The total secondary tax of the bill's line items of a service kind")
    services_sub_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The sub total of all the bill's line items of a service kind")
    services_tax: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The total tax of the bill's line items of a service kind")
    services_taxable_sub_total: Optional[StrictInt] = Field(default=None, description="The services portion of the bill's primary tax")
    services_secondary_taxable_sub_total: Optional[StrictInt] = Field(default=None, description="The services portion of the bill's secondary tax")
    taxable_sub_total: Optional[StrictInt] = Field(default=None, description="The total taxable bill amount")
    secondary_taxable_sub_total: Optional[StrictInt] = Field(default=None, description="The subtotal of the bill's secondary tax")
    sub_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Sub total for the *Bill*")
    tax_sum: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Sum of primary tax for the model")
    secondary_tax_sum: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Sum of secondary tax for the model")
    total_tax: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The total amount of tax for the bill.")
    available_state_transitions: Optional[StrictStr] = Field(default=None, description="The available *Bill* state transitions.")
    __properties = ["id", "etag", "number", "issued_at", "created_at", "due_at", "tax_rate", "secondary_tax_rate", "updated_at", "subject", "purchase_order", "type", "memo", "start_at", "end_at", "balance", "state", "kind", "total", "paid", "paid_at", "pending", "due", "discount_services_only", "can_update", "credits_issued", "shared", "last_sent_at", "services_secondary_tax", "services_sub_total", "services_tax", "services_taxable_sub_total", "services_secondary_taxable_sub_total", "taxable_sub_total", "secondary_taxable_sub_total", "sub_total", "tax_sum", "secondary_tax_sum", "total_tax", "available_state_transitions"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('MatterBill', 'ClientBill'):
            raise ValueError("must be one of enum values ('MatterBill', 'ClientBill')")
        return value

    @validator('state')
    def state_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('draft', 'awaiting_approval', 'awaiting_payment', 'paid', 'void', 'deleted'):
            raise ValueError("must be one of enum values ('draft', 'awaiting_approval', 'awaiting_payment', 'paid', 'void', 'deleted')")
        return value

    @validator('kind')
    def kind_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('revenue_kind', 'summary_kind', 'trust_kind', 'aggregate_all', 'aggregate_split', 'aggregate_services', 'aggregate_expenses'):
            raise ValueError("must be one of enum values ('revenue_kind', 'summary_kind', 'trust_kind', 'aggregate_all', 'aggregate_split', 'aggregate_services', 'aggregate_expenses')")
        return value

    @validator('available_state_transitions')
    def available_state_transitions_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('awaiting_approval', 'awaiting_payment', 'paid', 'void', 'deleted'):
            raise ValueError("must be one of enum values ('awaiting_approval', 'awaiting_payment', 'paid', 'void', 'deleted')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BillBase:
        """Create an instance of BillBase from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BillBase:
        """Create an instance of BillBase from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BillBase.parse_obj(obj)

        _obj = BillBase.parse_obj({
            "id": obj.get("id"),
            "etag": obj.get("etag"),
            "number": obj.get("number"),
            "issued_at": obj.get("issued_at"),
            "created_at": obj.get("created_at"),
            "due_at": obj.get("due_at"),
            "tax_rate": obj.get("tax_rate"),
            "secondary_tax_rate": obj.get("secondary_tax_rate"),
            "updated_at": obj.get("updated_at"),
            "subject": obj.get("subject"),
            "purchase_order": obj.get("purchase_order"),
            "type": obj.get("type"),
            "memo": obj.get("memo"),
            "start_at": obj.get("start_at"),
            "end_at": obj.get("end_at"),
            "balance": obj.get("balance"),
            "state": obj.get("state"),
            "kind": obj.get("kind"),
            "total": obj.get("total"),
            "paid": obj.get("paid"),
            "paid_at": obj.get("paid_at"),
            "pending": obj.get("pending"),
            "due": obj.get("due"),
            "discount_services_only": obj.get("discount_services_only"),
            "can_update": obj.get("can_update"),
            "credits_issued": obj.get("credits_issued"),
            "shared": obj.get("shared"),
            "last_sent_at": obj.get("last_sent_at"),
            "services_secondary_tax": obj.get("services_secondary_tax"),
            "services_sub_total": obj.get("services_sub_total"),
            "services_tax": obj.get("services_tax"),
            "services_taxable_sub_total": obj.get("services_taxable_sub_total"),
            "services_secondary_taxable_sub_total": obj.get("services_secondary_taxable_sub_total"),
            "taxable_sub_total": obj.get("taxable_sub_total"),
            "secondary_taxable_sub_total": obj.get("secondary_taxable_sub_total"),
            "sub_total": obj.get("sub_total"),
            "tax_sum": obj.get("tax_sum"),
            "secondary_tax_sum": obj.get("secondary_tax_sum"),
            "total_tax": obj.get("total_tax"),
            "available_state_transitions": obj.get("available_state_transitions")
        })
        return _obj


