# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr, validator
from clio-cli.models.bill_update_request_data_bill_theme import BillUpdateRequestDataBillTheme
from clio-cli.models.bill_update_request_data_discount import BillUpdateRequestDataDiscount
from clio-cli.models.bill_update_request_data_interest import BillUpdateRequestDataInterest

class BillUpdateRequestData(BaseModel):
    """
    BillUpdateRequestData
    """
    bill_theme: Optional[BillUpdateRequestDataBillTheme] = None
    currency_id: Optional[StrictInt] = Field(default=None, description="ID of the currency applied to the Bill.")
    discount: Optional[BillUpdateRequestDataDiscount] = None
    due_at: Optional[date] = Field(default=None, description="Date the Bill is due. If `use_grace_period` is true, this field is ignored.")
    interest: Optional[BillUpdateRequestDataInterest] = None
    issued_at: Optional[date] = Field(default=None, description="Date the Bill was issued.")
    memo: Optional[StrictStr] = Field(default=None, description="Memo for the Bill.")
    number: Optional[StrictStr] = Field(default=None, description="Bill's number.")
    purchase_order: Optional[StrictStr] = Field(default=None, description="Purchase order information for the Bill.")
    secondary_tax_rate: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Secondary tax rate as percentage for the Bill.")
    state: Optional[StrictStr] = Field(default=None, description="Bill's state.")
    subject: Optional[StrictStr] = Field(default=None, description="Subject details for the Bill.")
    tax_rate: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Tax rate as percentage for the Bill")
    use_grace_period: Optional[StrictBool] = Field(default=None, description="When true, sets the bill's due date based on the client's grace period. This setting overrides the `due_at` parameter.")
    __properties = ["bill_theme", "currency_id", "discount", "due_at", "interest", "issued_at", "memo", "number", "purchase_order", "secondary_tax_rate", "state", "subject", "tax_rate", "use_grace_period"]

    @validator('state')
    def state_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('draft', 'awaiting_approval', 'awaiting_payment', 'paid', 'void', 'deleted'):
            raise ValueError("must be one of enum values ('draft', 'awaiting_approval', 'awaiting_payment', 'paid', 'void', 'deleted')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BillUpdateRequestData:
        """Create an instance of BillUpdateRequestData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of bill_theme
        if self.bill_theme:
            _dict['bill_theme'] = self.bill_theme.to_dict()
        # override the default output from pydantic by calling `to_dict()` of discount
        if self.discount:
            _dict['discount'] = self.discount.to_dict()
        # override the default output from pydantic by calling `to_dict()` of interest
        if self.interest:
            _dict['interest'] = self.interest.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BillUpdateRequestData:
        """Create an instance of BillUpdateRequestData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BillUpdateRequestData.parse_obj(obj)

        _obj = BillUpdateRequestData.parse_obj({
            "bill_theme": BillUpdateRequestDataBillTheme.from_dict(obj.get("bill_theme")) if obj.get("bill_theme") is not None else None,
            "currency_id": obj.get("currency_id"),
            "discount": BillUpdateRequestDataDiscount.from_dict(obj.get("discount")) if obj.get("discount") is not None else None,
            "due_at": obj.get("due_at"),
            "interest": BillUpdateRequestDataInterest.from_dict(obj.get("interest")) if obj.get("interest") is not None else None,
            "issued_at": obj.get("issued_at"),
            "memo": obj.get("memo"),
            "number": obj.get("number"),
            "purchase_order": obj.get("purchase_order"),
            "secondary_tax_rate": obj.get("secondary_tax_rate"),
            "state": obj.get("state"),
            "subject": obj.get("subject"),
            "tax_rate": obj.get("tax_rate"),
            "use_grace_period": obj.get("use_grace_period")
        })
        return _obj


