# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date, datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist, validator
from clio-cli.models.account_balance_base import AccountBalanceBase
from clio-cli.models.activity_rate_base import ActivityRateBase
from clio-cli.models.address_base import AddressBase
from clio-cli.models.avatar_base import AvatarBase
from clio-cli.models.contact_base import ContactBase
from clio-cli.models.custom_field_set_association_base import CustomFieldSetAssociationBase
from clio-cli.models.custom_field_value import CustomFieldValue
from clio-cli.models.email_address_base import EmailAddressBase
from clio-cli.models.folder_base import FolderBase
from clio-cli.models.instant_messenger_base import InstantMessengerBase
from clio-cli.models.legal_aid_uk_contact_base import LegalAidUkContactBase
from clio-cli.models.notification_method_base import NotificationMethodBase
from clio-cli.models.payment_profile_base import PaymentProfileBase
from clio-cli.models.phone_number_base import PhoneNumberBase
from clio-cli.models.web_site_base import WebSiteBase

class Contact(BaseModel):
    """
    Contact
    """
    id: Optional[StrictInt] = Field(default=None, description="Unique identifier for the *Contact*")
    etag: Optional[StrictStr] = Field(default=None, description="ETag for the *Contact*")
    name: Optional[StrictStr] = Field(default=None, description="The full name of the *Contact*")
    first_name: Optional[StrictStr] = Field(default=None, description="First name of the Person")
    middle_name: Optional[StrictStr] = Field(default=None, description="Middle name of the Person")
    last_name: Optional[StrictStr] = Field(default=None, description="Last name of the Person")
    date_of_birth: Optional[date] = Field(default=None, description="Date of birth")
    type: Optional[StrictStr] = Field(default=None, description="The type of the *Contact*")
    created_at: Optional[datetime] = Field(default=None, description="The time the *Contact* was created (as a ISO-8601 timestamp)")
    updated_at: Optional[datetime] = Field(default=None, description="The time the *Contact* was last updated (as a ISO-8601 timestamp)")
    prefix: Optional[StrictStr] = Field(default=None, description="The prefix of the *Contact* (Mr, Mrs, etc)")
    title: Optional[StrictStr] = Field(default=None, description="The designated title of the *Contact*")
    initials: Optional[StrictStr] = Field(default=None, description="The initials of the *Contact*")
    clio_connect_email: Optional[StrictStr] = Field(default=None, description="Clio Connect email if the *Contact* is a ClioConnect User")
    locked_clio_connect_email: Optional[StrictBool] = Field(default=None, description="A boolean indicating if the ability to modify this *Contacts Clio connect email is locked.")
    client_connect_user_id: Optional[StrictInt] = Field(default=None, description="The ID for the Clio Connect user associated with this *Contact*")
    primary_email_address: Optional[StrictStr] = Field(default=None, description="The primary email address associated with this *Contact*.")
    secondary_email_address: Optional[StrictStr] = Field(default=None, description="The secondary email address associated with this *Contact*.")
    primary_phone_number: Optional[StrictStr] = Field(default=None, description="The primary phone number associated with this *Contact*.")
    secondary_phone_number: Optional[StrictStr] = Field(default=None, description="The secondary phone number of the *Contact*.")
    ledes_client_id: Optional[StrictStr] = Field(default=None, description="LEDES client id of the Contact")
    has_clio_for_clients_permission: Optional[StrictBool] = Field(default=None, description="True if at least one resource has been shared with the contact using Clio for Clients.")
    is_client: Optional[StrictBool] = Field(default=None, description="Whether or not the Contact is a client")
    is_clio_for_client_user: Optional[StrictBool] = Field(default=None, description="Whether or not this contact has client_login and client_user (can be created due to addition to client portal or client_share_permissions)")
    is_co_counsel: Optional[StrictBool] = Field(default=None, description="Whether or not the Contact has matters shared as co-counsel")
    is_bill_recipient: Optional[StrictBool] = Field(default=None, description="Whether the Contact is a bill recipient on at least one matter.")
    sales_tax_number: Optional[StrictStr] = Field(default=None, description="The sales tax number of the *Contact*")
    activity_rates: Optional[conlist(ActivityRateBase)] = Field(default=None, description="ActivityRate")
    addresses: Optional[conlist(AddressBase)] = Field(default=None, description="Address")
    custom_field_values: Optional[conlist(CustomFieldValue)] = Field(default=None, description="CustomFieldValue")
    custom_field_set_associations: Optional[conlist(CustomFieldSetAssociationBase)] = Field(default=None, description="CustomFieldSetAssociation")
    email_addresses: Optional[conlist(EmailAddressBase)] = Field(default=None, description="EmailAddress")
    instant_messengers: Optional[conlist(InstantMessengerBase)] = Field(default=None, description="InstantMessenger")
    phone_numbers: Optional[conlist(PhoneNumberBase)] = Field(default=None, description="PhoneNumber")
    web_sites: Optional[conlist(WebSiteBase)] = Field(default=None, description="WebSite")
    notification_methods: Optional[conlist(NotificationMethodBase)] = Field(default=None, description="NotificationMethod")
    account_balances: Optional[conlist(AccountBalanceBase)] = Field(default=None, description="AccountBalance")
    related_contacts: Optional[conlist(ContactBase)] = Field(default=None, description="Contact")
    primary_work_address: Optional[AddressBase] = None
    primary_address: Optional[AddressBase] = None
    secondary_address: Optional[AddressBase] = None
    company: Optional[ContactBase] = None
    avatar: Optional[AvatarBase] = None
    payment_profile: Optional[PaymentProfileBase] = None
    folder: Optional[FolderBase] = None
    co_counsel_rate: Optional[ActivityRateBase] = None
    primary_web_site: Optional[WebSiteBase] = None
    legal_aid_uk_contact: Optional[LegalAidUkContactBase] = None
    __properties = ["id", "etag", "name", "first_name", "middle_name", "last_name", "date_of_birth", "type", "created_at", "updated_at", "prefix", "title", "initials", "clio_connect_email", "locked_clio_connect_email", "client_connect_user_id", "primary_email_address", "secondary_email_address", "primary_phone_number", "secondary_phone_number", "ledes_client_id", "has_clio_for_clients_permission", "is_client", "is_clio_for_client_user", "is_co_counsel", "is_bill_recipient", "sales_tax_number", "activity_rates", "addresses", "custom_field_values", "custom_field_set_associations", "email_addresses", "instant_messengers", "phone_numbers", "web_sites", "notification_methods", "account_balances", "related_contacts", "primary_work_address", "primary_address", "secondary_address", "company", "avatar", "payment_profile", "folder", "co_counsel_rate", "primary_web_site", "legal_aid_uk_contact"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Company', 'Person'):
            raise ValueError("must be one of enum values ('Company', 'Person')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Contact:
        """Create an instance of Contact from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in activity_rates (list)
        _items = []
        if self.activity_rates:
            for _item in self.activity_rates:
                if _item:
                    _items.append(_item.to_dict())
            _dict['activity_rates'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in addresses (list)
        _items = []
        if self.addresses:
            for _item in self.addresses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['addresses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in custom_field_values (list)
        _items = []
        if self.custom_field_values:
            for _item in self.custom_field_values:
                if _item:
                    _items.append(_item.to_dict())
            _dict['custom_field_values'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in custom_field_set_associations (list)
        _items = []
        if self.custom_field_set_associations:
            for _item in self.custom_field_set_associations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['custom_field_set_associations'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in email_addresses (list)
        _items = []
        if self.email_addresses:
            for _item in self.email_addresses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['email_addresses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in instant_messengers (list)
        _items = []
        if self.instant_messengers:
            for _item in self.instant_messengers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['instant_messengers'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in phone_numbers (list)
        _items = []
        if self.phone_numbers:
            for _item in self.phone_numbers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['phone_numbers'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in web_sites (list)
        _items = []
        if self.web_sites:
            for _item in self.web_sites:
                if _item:
                    _items.append(_item.to_dict())
            _dict['web_sites'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in notification_methods (list)
        _items = []
        if self.notification_methods:
            for _item in self.notification_methods:
                if _item:
                    _items.append(_item.to_dict())
            _dict['notification_methods'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in account_balances (list)
        _items = []
        if self.account_balances:
            for _item in self.account_balances:
                if _item:
                    _items.append(_item.to_dict())
            _dict['account_balances'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in related_contacts (list)
        _items = []
        if self.related_contacts:
            for _item in self.related_contacts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['related_contacts'] = _items
        # override the default output from pydantic by calling `to_dict()` of primary_work_address
        if self.primary_work_address:
            _dict['primary_work_address'] = self.primary_work_address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of primary_address
        if self.primary_address:
            _dict['primary_address'] = self.primary_address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of secondary_address
        if self.secondary_address:
            _dict['secondary_address'] = self.secondary_address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of company
        if self.company:
            _dict['company'] = self.company.to_dict()
        # override the default output from pydantic by calling `to_dict()` of avatar
        if self.avatar:
            _dict['avatar'] = self.avatar.to_dict()
        # override the default output from pydantic by calling `to_dict()` of payment_profile
        if self.payment_profile:
            _dict['payment_profile'] = self.payment_profile.to_dict()
        # override the default output from pydantic by calling `to_dict()` of folder
        if self.folder:
            _dict['folder'] = self.folder.to_dict()
        # override the default output from pydantic by calling `to_dict()` of co_counsel_rate
        if self.co_counsel_rate:
            _dict['co_counsel_rate'] = self.co_counsel_rate.to_dict()
        # override the default output from pydantic by calling `to_dict()` of primary_web_site
        if self.primary_web_site:
            _dict['primary_web_site'] = self.primary_web_site.to_dict()
        # override the default output from pydantic by calling `to_dict()` of legal_aid_uk_contact
        if self.legal_aid_uk_contact:
            _dict['legal_aid_uk_contact'] = self.legal_aid_uk_contact.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Contact:
        """Create an instance of Contact from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Contact.parse_obj(obj)

        _obj = Contact.parse_obj({
            "id": obj.get("id"),
            "etag": obj.get("etag"),
            "name": obj.get("name"),
            "first_name": obj.get("first_name"),
            "middle_name": obj.get("middle_name"),
            "last_name": obj.get("last_name"),
            "date_of_birth": obj.get("date_of_birth"),
            "type": obj.get("type"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "prefix": obj.get("prefix"),
            "title": obj.get("title"),
            "initials": obj.get("initials"),
            "clio_connect_email": obj.get("clio_connect_email"),
            "locked_clio_connect_email": obj.get("locked_clio_connect_email"),
            "client_connect_user_id": obj.get("client_connect_user_id"),
            "primary_email_address": obj.get("primary_email_address"),
            "secondary_email_address": obj.get("secondary_email_address"),
            "primary_phone_number": obj.get("primary_phone_number"),
            "secondary_phone_number": obj.get("secondary_phone_number"),
            "ledes_client_id": obj.get("ledes_client_id"),
            "has_clio_for_clients_permission": obj.get("has_clio_for_clients_permission"),
            "is_client": obj.get("is_client"),
            "is_clio_for_client_user": obj.get("is_clio_for_client_user"),
            "is_co_counsel": obj.get("is_co_counsel"),
            "is_bill_recipient": obj.get("is_bill_recipient"),
            "sales_tax_number": obj.get("sales_tax_number"),
            "activity_rates": [ActivityRateBase.from_dict(_item) for _item in obj.get("activity_rates")] if obj.get("activity_rates") is not None else None,
            "addresses": [AddressBase.from_dict(_item) for _item in obj.get("addresses")] if obj.get("addresses") is not None else None,
            "custom_field_values": [CustomFieldValue.from_dict(_item) for _item in obj.get("custom_field_values")] if obj.get("custom_field_values") is not None else None,
            "custom_field_set_associations": [CustomFieldSetAssociationBase.from_dict(_item) for _item in obj.get("custom_field_set_associations")] if obj.get("custom_field_set_associations") is not None else None,
            "email_addresses": [EmailAddressBase.from_dict(_item) for _item in obj.get("email_addresses")] if obj.get("email_addresses") is not None else None,
            "instant_messengers": [InstantMessengerBase.from_dict(_item) for _item in obj.get("instant_messengers")] if obj.get("instant_messengers") is not None else None,
            "phone_numbers": [PhoneNumberBase.from_dict(_item) for _item in obj.get("phone_numbers")] if obj.get("phone_numbers") is not None else None,
            "web_sites": [WebSiteBase.from_dict(_item) for _item in obj.get("web_sites")] if obj.get("web_sites") is not None else None,
            "notification_methods": [NotificationMethodBase.from_dict(_item) for _item in obj.get("notification_methods")] if obj.get("notification_methods") is not None else None,
            "account_balances": [AccountBalanceBase.from_dict(_item) for _item in obj.get("account_balances")] if obj.get("account_balances") is not None else None,
            "related_contacts": [ContactBase.from_dict(_item) for _item in obj.get("related_contacts")] if obj.get("related_contacts") is not None else None,
            "primary_work_address": AddressBase.from_dict(obj.get("primary_work_address")) if obj.get("primary_work_address") is not None else None,
            "primary_address": AddressBase.from_dict(obj.get("primary_address")) if obj.get("primary_address") is not None else None,
            "secondary_address": AddressBase.from_dict(obj.get("secondary_address")) if obj.get("secondary_address") is not None else None,
            "company": ContactBase.from_dict(obj.get("company")) if obj.get("company") is not None else None,
            "avatar": AvatarBase.from_dict(obj.get("avatar")) if obj.get("avatar") is not None else None,
            "payment_profile": PaymentProfileBase.from_dict(obj.get("payment_profile")) if obj.get("payment_profile") is not None else None,
            "folder": FolderBase.from_dict(obj.get("folder")) if obj.get("folder") is not None else None,
            "co_counsel_rate": ActivityRateBase.from_dict(obj.get("co_counsel_rate")) if obj.get("co_counsel_rate") is not None else None,
            "primary_web_site": WebSiteBase.from_dict(obj.get("primary_web_site")) if obj.get("primary_web_site") is not None else None,
            "legal_aid_uk_contact": LegalAidUkContactBase.from_dict(obj.get("legal_aid_uk_contact")) if obj.get("legal_aid_uk_contact") is not None else None
        })
        return _obj


