# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date, datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, validator

class ContactBase(BaseModel):
    """
    ContactBase
    """
    id: Optional[StrictInt] = Field(default=None, description="Unique identifier for the *Contact*")
    etag: Optional[StrictStr] = Field(default=None, description="ETag for the *Contact*")
    name: Optional[StrictStr] = Field(default=None, description="The full name of the *Contact*")
    first_name: Optional[StrictStr] = Field(default=None, description="First name of the Person")
    middle_name: Optional[StrictStr] = Field(default=None, description="Middle name of the Person")
    last_name: Optional[StrictStr] = Field(default=None, description="Last name of the Person")
    date_of_birth: Optional[date] = Field(default=None, description="Date of birth")
    type: Optional[StrictStr] = Field(default=None, description="The type of the *Contact*")
    created_at: Optional[datetime] = Field(default=None, description="The time the *Contact* was created (as a ISO-8601 timestamp)")
    updated_at: Optional[datetime] = Field(default=None, description="The time the *Contact* was last updated (as a ISO-8601 timestamp)")
    prefix: Optional[StrictStr] = Field(default=None, description="The prefix of the *Contact* (Mr, Mrs, etc)")
    title: Optional[StrictStr] = Field(default=None, description="The designated title of the *Contact*")
    initials: Optional[StrictStr] = Field(default=None, description="The initials of the *Contact*")
    clio_connect_email: Optional[StrictStr] = Field(default=None, description="Clio Connect email if the *Contact* is a ClioConnect User")
    locked_clio_connect_email: Optional[StrictBool] = Field(default=None, description="A boolean indicating if the ability to modify this *Contacts Clio connect email is locked.")
    client_connect_user_id: Optional[StrictInt] = Field(default=None, description="The ID for the Clio Connect user associated with this *Contact*")
    primary_email_address: Optional[StrictStr] = Field(default=None, description="The primary email address associated with this *Contact*.")
    secondary_email_address: Optional[StrictStr] = Field(default=None, description="The secondary email address associated with this *Contact*.")
    primary_phone_number: Optional[StrictStr] = Field(default=None, description="The primary phone number associated with this *Contact*.")
    secondary_phone_number: Optional[StrictStr] = Field(default=None, description="The secondary phone number of the *Contact*.")
    ledes_client_id: Optional[StrictStr] = Field(default=None, description="LEDES client id of the Contact")
    has_clio_for_clients_permission: Optional[StrictBool] = Field(default=None, description="True if at least one resource has been shared with the contact using Clio for Clients.")
    is_client: Optional[StrictBool] = Field(default=None, description="Whether or not the Contact is a client")
    is_clio_for_client_user: Optional[StrictBool] = Field(default=None, description="Whether or not this contact has client_login and client_user (can be created due to addition to client portal or client_share_permissions)")
    is_co_counsel: Optional[StrictBool] = Field(default=None, description="Whether or not the Contact has matters shared as co-counsel")
    is_bill_recipient: Optional[StrictBool] = Field(default=None, description="Whether the Contact is a bill recipient on at least one matter.")
    sales_tax_number: Optional[StrictStr] = Field(default=None, description="The sales tax number of the *Contact*")
    __properties = ["id", "etag", "name", "first_name", "middle_name", "last_name", "date_of_birth", "type", "created_at", "updated_at", "prefix", "title", "initials", "clio_connect_email", "locked_clio_connect_email", "client_connect_user_id", "primary_email_address", "secondary_email_address", "primary_phone_number", "secondary_phone_number", "ledes_client_id", "has_clio_for_clients_permission", "is_client", "is_clio_for_client_user", "is_co_counsel", "is_bill_recipient", "sales_tax_number"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Company', 'Person'):
            raise ValueError("must be one of enum values ('Company', 'Person')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ContactBase:
        """Create an instance of ContactBase from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ContactBase:
        """Create an instance of ContactBase from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ContactBase.parse_obj(obj)

        _obj = ContactBase.parse_obj({
            "id": obj.get("id"),
            "etag": obj.get("etag"),
            "name": obj.get("name"),
            "first_name": obj.get("first_name"),
            "middle_name": obj.get("middle_name"),
            "last_name": obj.get("last_name"),
            "date_of_birth": obj.get("date_of_birth"),
            "type": obj.get("type"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "prefix": obj.get("prefix"),
            "title": obj.get("title"),
            "initials": obj.get("initials"),
            "clio_connect_email": obj.get("clio_connect_email"),
            "locked_clio_connect_email": obj.get("locked_clio_connect_email"),
            "client_connect_user_id": obj.get("client_connect_user_id"),
            "primary_email_address": obj.get("primary_email_address"),
            "secondary_email_address": obj.get("secondary_email_address"),
            "primary_phone_number": obj.get("primary_phone_number"),
            "secondary_phone_number": obj.get("secondary_phone_number"),
            "ledes_client_id": obj.get("ledes_client_id"),
            "has_clio_for_clients_permission": obj.get("has_clio_for_clients_permission"),
            "is_client": obj.get("is_client"),
            "is_clio_for_client_user": obj.get("is_clio_for_client_user"),
            "is_co_counsel": obj.get("is_co_counsel"),
            "is_bill_recipient": obj.get("is_bill_recipient"),
            "sales_tax_number": obj.get("sales_tax_number")
        })
        return _obj


