# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist, validator
from clio-cli.models.contact_create_request_data_avatar import ContactCreateRequestDataAvatar
from clio-cli.models.contact_create_request_data_co_counsel_rate import ContactCreateRequestDataCoCounselRate
from clio-cli.models.contact_create_request_data_company import ContactCreateRequestDataCompany
from clio-cli.models.contact_update_request_data_addresses_inner import ContactUpdateRequestDataAddressesInner
from clio-cli.models.contact_update_request_data_custom_field_set_associations_inner import ContactUpdateRequestDataCustomFieldSetAssociationsInner
from clio-cli.models.contact_update_request_data_custom_field_values_inner import ContactUpdateRequestDataCustomFieldValuesInner
from clio-cli.models.contact_update_request_data_email_addresses_inner import ContactUpdateRequestDataEmailAddressesInner
from clio-cli.models.contact_update_request_data_instant_messengers_inner import ContactUpdateRequestDataInstantMessengersInner
from clio-cli.models.contact_update_request_data_phone_numbers_inner import ContactUpdateRequestDataPhoneNumbersInner
from clio-cli.models.contact_update_request_data_web_sites_inner import ContactUpdateRequestDataWebSitesInner

class ContactUpdateRequestData(BaseModel):
    """
    ContactUpdateRequestData
    """
    addresses: Optional[conlist(ContactUpdateRequestDataAddressesInner)] = None
    avatar: Optional[ContactCreateRequestDataAvatar] = None
    clio_connect_email: Optional[StrictStr] = Field(default=None, description="Notifications will be sent to this email when a resource is shared.")
    co_counsel_rate: Optional[ContactCreateRequestDataCoCounselRate] = None
    company: Optional[ContactCreateRequestDataCompany] = None
    custom_field_set_associations: Optional[conlist(ContactUpdateRequestDataCustomFieldSetAssociationsInner)] = None
    custom_field_values: Optional[conlist(ContactUpdateRequestDataCustomFieldValuesInner)] = None
    date_of_birth: Optional[date] = Field(default=None, description="Date of birth of the Contact.")
    email_addresses: Optional[conlist(ContactUpdateRequestDataEmailAddressesInner)] = None
    first_name: Optional[StrictStr] = Field(default=None, description="First name of the Contact.")
    instant_messengers: Optional[conlist(ContactUpdateRequestDataInstantMessengersInner)] = None
    last_name: Optional[StrictStr] = Field(default=None, description="Last name of the Contact.")
    ledes_client_id: Optional[StrictStr] = Field(default=None, description="LEDES client id of the Contact.")
    middle_name: Optional[StrictStr] = Field(default=None, description="Middle name of the Contact.")
    name: Optional[StrictStr] = Field(default=None, description="Full name of the Contact. For requirements, see [Contact Name](https://docs.developers.clio.com/api-reference/#section/Contact-Name).")
    phone_numbers: Optional[conlist(ContactUpdateRequestDataPhoneNumbersInner)] = None
    prefix: Optional[StrictStr] = Field(default=None, description="Personal title of the Contact.")
    sales_tax_number: Optional[StrictStr] = Field(default=None, description="A contact's sales tax number will appear on invoices generated for the Contact.")
    title: Optional[StrictStr] = Field(default=None, description="Professional title of the Contact.")
    type: Optional[StrictStr] = Field(default=None, description="Type of the Contact.")
    web_sites: Optional[conlist(ContactUpdateRequestDataWebSitesInner)] = None
    __properties = ["addresses", "avatar", "clio_connect_email", "co_counsel_rate", "company", "custom_field_set_associations", "custom_field_values", "date_of_birth", "email_addresses", "first_name", "instant_messengers", "last_name", "ledes_client_id", "middle_name", "name", "phone_numbers", "prefix", "sales_tax_number", "title", "type", "web_sites"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Person', 'Company'):
            raise ValueError("must be one of enum values ('Person', 'Company')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ContactUpdateRequestData:
        """Create an instance of ContactUpdateRequestData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in addresses (list)
        _items = []
        if self.addresses:
            for _item in self.addresses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['addresses'] = _items
        # override the default output from pydantic by calling `to_dict()` of avatar
        if self.avatar:
            _dict['avatar'] = self.avatar.to_dict()
        # override the default output from pydantic by calling `to_dict()` of co_counsel_rate
        if self.co_counsel_rate:
            _dict['co_counsel_rate'] = self.co_counsel_rate.to_dict()
        # override the default output from pydantic by calling `to_dict()` of company
        if self.company:
            _dict['company'] = self.company.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in custom_field_set_associations (list)
        _items = []
        if self.custom_field_set_associations:
            for _item in self.custom_field_set_associations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['custom_field_set_associations'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in custom_field_values (list)
        _items = []
        if self.custom_field_values:
            for _item in self.custom_field_values:
                if _item:
                    _items.append(_item.to_dict())
            _dict['custom_field_values'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in email_addresses (list)
        _items = []
        if self.email_addresses:
            for _item in self.email_addresses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['email_addresses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in instant_messengers (list)
        _items = []
        if self.instant_messengers:
            for _item in self.instant_messengers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['instant_messengers'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in phone_numbers (list)
        _items = []
        if self.phone_numbers:
            for _item in self.phone_numbers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['phone_numbers'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in web_sites (list)
        _items = []
        if self.web_sites:
            for _item in self.web_sites:
                if _item:
                    _items.append(_item.to_dict())
            _dict['web_sites'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ContactUpdateRequestData:
        """Create an instance of ContactUpdateRequestData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ContactUpdateRequestData.parse_obj(obj)

        _obj = ContactUpdateRequestData.parse_obj({
            "addresses": [ContactUpdateRequestDataAddressesInner.from_dict(_item) for _item in obj.get("addresses")] if obj.get("addresses") is not None else None,
            "avatar": ContactCreateRequestDataAvatar.from_dict(obj.get("avatar")) if obj.get("avatar") is not None else None,
            "clio_connect_email": obj.get("clio_connect_email"),
            "co_counsel_rate": ContactCreateRequestDataCoCounselRate.from_dict(obj.get("co_counsel_rate")) if obj.get("co_counsel_rate") is not None else None,
            "company": ContactCreateRequestDataCompany.from_dict(obj.get("company")) if obj.get("company") is not None else None,
            "custom_field_set_associations": [ContactUpdateRequestDataCustomFieldSetAssociationsInner.from_dict(_item) for _item in obj.get("custom_field_set_associations")] if obj.get("custom_field_set_associations") is not None else None,
            "custom_field_values": [ContactUpdateRequestDataCustomFieldValuesInner.from_dict(_item) for _item in obj.get("custom_field_values")] if obj.get("custom_field_values") is not None else None,
            "date_of_birth": obj.get("date_of_birth"),
            "email_addresses": [ContactUpdateRequestDataEmailAddressesInner.from_dict(_item) for _item in obj.get("email_addresses")] if obj.get("email_addresses") is not None else None,
            "first_name": obj.get("first_name"),
            "instant_messengers": [ContactUpdateRequestDataInstantMessengersInner.from_dict(_item) for _item in obj.get("instant_messengers")] if obj.get("instant_messengers") is not None else None,
            "last_name": obj.get("last_name"),
            "ledes_client_id": obj.get("ledes_client_id"),
            "middle_name": obj.get("middle_name"),
            "name": obj.get("name"),
            "phone_numbers": [ContactUpdateRequestDataPhoneNumbersInner.from_dict(_item) for _item in obj.get("phone_numbers")] if obj.get("phone_numbers") is not None else None,
            "prefix": obj.get("prefix"),
            "sales_tax_number": obj.get("sales_tax_number"),
            "title": obj.get("title"),
            "type": obj.get("type"),
            "web_sites": [ContactUpdateRequestDataWebSitesInner.from_dict(_item) for _item in obj.get("web_sites")] if obj.get("web_sites") is not None else None
        })
        return _obj


