# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist
from clio-cli.models.conversation_membership import ConversationMembership
from clio-cli.models.conversation_message_base import ConversationMessageBase
from clio-cli.models.document_base import DocumentBase
from clio-cli.models.matter_base import MatterBase

class Conversation(BaseModel):
    """
    Conversation
    """
    id: Optional[StrictInt] = Field(default=None, description="Unique identifier for the *Conversation*")
    etag: Optional[StrictStr] = Field(default=None, description="ETag for the *Conversation*")
    archived: Optional[StrictBool] = Field(default=None, description="Whether the conversation has been archived")
    read_only: Optional[StrictBool] = Field(default=None, description="Whether the conversation is read only")
    current_user_is_member: Optional[StrictBool] = Field(default=None, description="Whether the current user is a member of this conversation")
    subject: Optional[StrictStr] = Field(default=None, description="The subject of the *Conversation*")
    message_count: Optional[StrictInt] = Field(default=None, description="The number of messages in this conversation")
    time_entries_count: Optional[StrictInt] = Field(default=None, description="The number of time entries applied to this conversation")
    read: Optional[StrictBool] = Field(default=None, description="Whether any messages in this conversation have been viewed")
    created_at: Optional[datetime] = Field(default=None, description="The time the *Conversation* was created (as a ISO-8601 timestamp)")
    updated_at: Optional[datetime] = Field(default=None, description="The time the *Conversation* was last updated (as a ISO-8601 timestamp)")
    last_message: Optional[ConversationMessageBase] = None
    first_message: Optional[ConversationMessageBase] = None
    matter: Optional[MatterBase] = None
    messages: Optional[conlist(ConversationMessageBase)] = Field(default=None, description="ConversationMessage")
    documents: Optional[conlist(DocumentBase)] = Field(default=None, description="Document")
    memberships: Optional[conlist(ConversationMembership)] = Field(default=None, description="ConversationMembership")
    __properties = ["id", "etag", "archived", "read_only", "current_user_is_member", "subject", "message_count", "time_entries_count", "read", "created_at", "updated_at", "last_message", "first_message", "matter", "messages", "documents", "memberships"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Conversation:
        """Create an instance of Conversation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of last_message
        if self.last_message:
            _dict['last_message'] = self.last_message.to_dict()
        # override the default output from pydantic by calling `to_dict()` of first_message
        if self.first_message:
            _dict['first_message'] = self.first_message.to_dict()
        # override the default output from pydantic by calling `to_dict()` of matter
        if self.matter:
            _dict['matter'] = self.matter.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in messages (list)
        _items = []
        if self.messages:
            for _item in self.messages:
                if _item:
                    _items.append(_item.to_dict())
            _dict['messages'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in documents (list)
        _items = []
        if self.documents:
            for _item in self.documents:
                if _item:
                    _items.append(_item.to_dict())
            _dict['documents'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in memberships (list)
        _items = []
        if self.memberships:
            for _item in self.memberships:
                if _item:
                    _items.append(_item.to_dict())
            _dict['memberships'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Conversation:
        """Create an instance of Conversation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Conversation.parse_obj(obj)

        _obj = Conversation.parse_obj({
            "id": obj.get("id"),
            "etag": obj.get("etag"),
            "archived": obj.get("archived"),
            "read_only": obj.get("read_only"),
            "current_user_is_member": obj.get("current_user_is_member"),
            "subject": obj.get("subject"),
            "message_count": obj.get("message_count"),
            "time_entries_count": obj.get("time_entries_count"),
            "read": obj.get("read"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "last_message": ConversationMessageBase.from_dict(obj.get("last_message")) if obj.get("last_message") is not None else None,
            "first_message": ConversationMessageBase.from_dict(obj.get("first_message")) if obj.get("first_message") is not None else None,
            "matter": MatterBase.from_dict(obj.get("matter")) if obj.get("matter") is not None else None,
            "messages": [ConversationMessageBase.from_dict(_item) for _item in obj.get("messages")] if obj.get("messages") is not None else None,
            "documents": [DocumentBase.from_dict(_item) for _item in obj.get("documents")] if obj.get("documents") is not None else None,
            "memberships": [ConversationMembership.from_dict(_item) for _item in obj.get("memberships")] if obj.get("memberships") is not None else None
        })
        return _obj


