# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist, validator
from clio-cli.models.picklist_option_base import PicklistOptionBase

class CustomField(BaseModel):
    """
    CustomField
    """
    id: Optional[StrictInt] = Field(default=None, description="Unique identifier for the *CustomField*")
    etag: Optional[StrictStr] = Field(default=None, description="ETag for the *CustomField*")
    created_at: Optional[datetime] = Field(default=None, description="The time the *CustomField* was created (as a ISO-8601 timestamp)")
    updated_at: Optional[datetime] = Field(default=None, description="The time the *CustomField* was last updated (as a ISO-8601 timestamp)")
    name: Optional[StrictStr] = Field(default=None, description="The name of the *CustomField*")
    parent_type: Optional[StrictStr] = Field(default=None, description="Type of object the *CustomField* is for")
    field_type: Optional[StrictStr] = Field(default=None, description="Field type of the *CustomField*")
    displayed: Optional[StrictBool] = Field(default=None, description="Whether the *CustomField* is displayed by default")
    deleted: Optional[StrictBool] = Field(default=None, description="Whether the *CustomField* is deleted for future use")
    required: Optional[StrictBool] = Field(default=None, description="Whether the *CustomField* requires a value")
    display_order: Optional[StrictInt] = Field(default=None, description="The display position of the *CustomField*")
    picklist_options: Optional[conlist(PicklistOptionBase)] = Field(default=None, description="PicklistOption")
    __properties = ["id", "etag", "created_at", "updated_at", "name", "parent_type", "field_type", "displayed", "deleted", "required", "display_order", "picklist_options"]

    @validator('parent_type')
    def parent_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Contact', 'Matter'):
            raise ValueError("must be one of enum values ('Contact', 'Matter')")
        return value

    @validator('field_type')
    def field_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('checkbox', 'contact', 'currency', 'date', 'time', 'email', 'matter', 'numeric', 'picklist', 'text_area', 'text_line', 'url'):
            raise ValueError("must be one of enum values ('checkbox', 'contact', 'currency', 'date', 'time', 'email', 'matter', 'numeric', 'picklist', 'text_area', 'text_line', 'url')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CustomField:
        """Create an instance of CustomField from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in picklist_options (list)
        _items = []
        if self.picklist_options:
            for _item in self.picklist_options:
                if _item:
                    _items.append(_item.to_dict())
            _dict['picklist_options'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CustomField:
        """Create an instance of CustomField from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CustomField.parse_obj(obj)

        _obj = CustomField.parse_obj({
            "id": obj.get("id"),
            "etag": obj.get("etag"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "name": obj.get("name"),
            "parent_type": obj.get("parent_type"),
            "field_type": obj.get("field_type"),
            "displayed": obj.get("displayed"),
            "deleted": obj.get("deleted"),
            "required": obj.get("required"),
            "display_order": obj.get("display_order"),
            "picklist_options": [PicklistOptionBase.from_dict(_item) for _item in obj.get("picklist_options")] if obj.get("picklist_options") is not None else None
        })
        return _obj


