# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist, validator
from clio-cli.models.clio_creator_base import ClioCreatorBase
from clio-cli.models.contact_base import ContactBase
from clio-cli.models.document_category_base import DocumentCategoryBase
from clio-cli.models.document_version import DocumentVersion
from clio-cli.models.document_version_base import DocumentVersionBase
from clio-cli.models.external_property_base import ExternalPropertyBase
from clio-cli.models.group_base import GroupBase
from clio-cli.models.linked_folder_base import LinkedFolderBase
from clio-cli.models.matter_base import MatterBase

class Document(BaseModel):
    """
    Document
    """
    id: Optional[StrictInt] = Field(default=None, description="Unique identifier for the *Document*")
    etag: Optional[StrictStr] = Field(default=None, description="ETag for the *Document*")
    created_at: Optional[datetime] = Field(default=None, description="The time the *Document* was created (as a ISO-8601 timestamp)")
    updated_at: Optional[datetime] = Field(default=None, description="The time the *Document* was last updated (as a ISO-8601 timestamp)")
    deleted_at: Optional[datetime] = Field(default=None, description="The time the *Document* was deleted (as a ISO-8601 timestamp)")
    type: Optional[StrictStr] = Field(default=None, description="The type of the *Document*")
    locked: Optional[StrictBool] = Field(default=None, description="Whether or not the Document is locked. Locked Document cannot be modified")
    name: Optional[StrictStr] = Field(default=None, description="The name of the Document")
    received_at: Optional[datetime] = Field(default=None, description="The time the last document version was received (as an ISO-8601 timestamp)")
    filename: Optional[StrictStr] = Field(default=None, description="The uploaded file name of the latest document version.")
    size: Optional[StrictInt] = Field(default=None, description="The file size")
    content_type: Optional[StrictStr] = Field(default=None, description="The uploaded file content type")
    parent: Optional[LinkedFolderBase] = None
    matter: Optional[MatterBase] = None
    contact: Optional[ContactBase] = None
    document_category: Optional[DocumentCategoryBase] = None
    creator: Optional[ClioCreatorBase] = None
    latest_document_version: Optional[DocumentVersion] = None
    group: Optional[GroupBase] = None
    external_properties: Optional[conlist(ExternalPropertyBase)] = Field(default=None, description="ExternalProperty")
    document_versions: Optional[conlist(DocumentVersionBase)] = Field(default=None, description="DocumentVersion")
    __properties = ["id", "etag", "created_at", "updated_at", "deleted_at", "type", "locked", "name", "received_at", "filename", "size", "content_type", "parent", "matter", "contact", "document_category", "creator", "latest_document_version", "group", "external_properties", "document_versions"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Document'):
            raise ValueError("must be one of enum values ('Document')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Document:
        """Create an instance of Document from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of parent
        if self.parent:
            _dict['parent'] = self.parent.to_dict()
        # override the default output from pydantic by calling `to_dict()` of matter
        if self.matter:
            _dict['matter'] = self.matter.to_dict()
        # override the default output from pydantic by calling `to_dict()` of contact
        if self.contact:
            _dict['contact'] = self.contact.to_dict()
        # override the default output from pydantic by calling `to_dict()` of document_category
        if self.document_category:
            _dict['document_category'] = self.document_category.to_dict()
        # override the default output from pydantic by calling `to_dict()` of creator
        if self.creator:
            _dict['creator'] = self.creator.to_dict()
        # override the default output from pydantic by calling `to_dict()` of latest_document_version
        if self.latest_document_version:
            _dict['latest_document_version'] = self.latest_document_version.to_dict()
        # override the default output from pydantic by calling `to_dict()` of group
        if self.group:
            _dict['group'] = self.group.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in external_properties (list)
        _items = []
        if self.external_properties:
            for _item in self.external_properties:
                if _item:
                    _items.append(_item.to_dict())
            _dict['external_properties'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in document_versions (list)
        _items = []
        if self.document_versions:
            for _item in self.document_versions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['document_versions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Document:
        """Create an instance of Document from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Document.parse_obj(obj)

        _obj = Document.parse_obj({
            "id": obj.get("id"),
            "etag": obj.get("etag"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "deleted_at": obj.get("deleted_at"),
            "type": obj.get("type"),
            "locked": obj.get("locked"),
            "name": obj.get("name"),
            "received_at": obj.get("received_at"),
            "filename": obj.get("filename"),
            "size": obj.get("size"),
            "content_type": obj.get("content_type"),
            "parent": LinkedFolderBase.from_dict(obj.get("parent")) if obj.get("parent") is not None else None,
            "matter": MatterBase.from_dict(obj.get("matter")) if obj.get("matter") is not None else None,
            "contact": ContactBase.from_dict(obj.get("contact")) if obj.get("contact") is not None else None,
            "document_category": DocumentCategoryBase.from_dict(obj.get("document_category")) if obj.get("document_category") is not None else None,
            "creator": ClioCreatorBase.from_dict(obj.get("creator")) if obj.get("creator") is not None else None,
            "latest_document_version": DocumentVersion.from_dict(obj.get("latest_document_version")) if obj.get("latest_document_version") is not None else None,
            "group": GroupBase.from_dict(obj.get("group")) if obj.get("group") is not None else None,
            "external_properties": [ExternalPropertyBase.from_dict(_item) for _item in obj.get("external_properties")] if obj.get("external_properties") is not None else None,
            "document_versions": [DocumentVersionBase.from_dict(_item) for _item in obj.get("document_versions")] if obj.get("document_versions") is not None else None
        })
        return _obj


