# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr

class LegalAidUkBillBase(BaseModel):
    """
    LegalAidUkBillBase
    """
    additional_travel_payment: Optional[StrictBool] = Field(default=None, description="Additional travel payment, for Legal Aid England and Wales")
    adjourned_hearing_fee: Optional[StrictStr] = Field(default=None, description="Adjourned hearing fee")
    advocacy_costs: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Advocacy costs")
    advice_time: Optional[StrictInt] = Field(default=None, description="Advice time")
    bill_type: Optional[StrictInt] = Field(default=None, description="Bill type")
    case_concluded: Optional[date] = Field(default=None, description="Case concluded")
    case_stage_level: Optional[StrictInt] = Field(default=None, description="Case stage level")
    cla_exemption_code: Optional[StrictStr] = Field(default=None, description="CLA exemption code")
    cla_reference: Optional[StrictStr] = Field(default=None, description="CLA reference")
    cmrh_oral: Optional[StrictInt] = Field(default=None, description="CMRH oral")
    cmrh_telephone: Optional[StrictInt] = Field(default=None, description="CMRH telephone")
    cost_of_counsel: Optional[StrictStr] = Field(default=None, description="Cost of counsel")
    costs_are_those_of: Optional[StrictInt] = Field(default=None, description="Costs are those of")
    court_location: Optional[StrictStr] = Field(default=None, description="Court location (HPCDS matters)")
    date_of_claim: Optional[date] = Field(default=None, description="Date of claim")
    designated_accredited_representative: Optional[StrictInt] = Field(default=None, description="Designated accredited representative")
    detention_travel_and_waiting_costs: Optional[StrictStr] = Field(default=None, description="Detention travel & waiting costs ex VAT")
    disbursements_vat: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Disbursements VAT")
    exceptional_case_funding_reference: Optional[StrictStr] = Field(default=None, description="Exceptional case funding reference")
    exemption_criteria_satisfied: Optional[StrictInt] = Field(default=None, description="Exemption criteria satisfied")
    follow_on_work: Optional[StrictInt] = Field(default=None, description="Follow on work")
    ho_interview: Optional[StrictInt] = Field(default=None, description="HO interview")
    ho_ucn: Optional[StrictInt] = Field(default=None, description="HO UCN")
    id: Optional[StrictInt] = Field(default=None, description="Unique identifier for the *LegalAidUkBill*")
    independent_medical_reports_claimed: Optional[StrictStr] = Field(default=None, description="Independent medical reports claimed")
    jr_form_filling: Optional[StrictStr] = Field(default=None, description="JR/Form filling ex VAT, for Legal Aid England and Wales")
    maat_id: Optional[StrictStr] = Field(default=None, description="MAAT ID")
    meetings_attended: Optional[StrictInt] = Field(default=None, description="Meetings attended")
    mht_ref_no: Optional[StrictStr] = Field(default=None, description="MHT reference number")
    net_disbursements: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Net disbursements")
    net_profit_costs: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Net profit cost")
    niat_disbursement_prior_authority_number: Optional[StrictStr] = Field(default=None, description="NIAT disbursement prior authority number")
    number_of_attendances: Optional[StrictInt] = Field(default=None, description="Number of attendances")
    outcome_for_the_client: Optional[StrictInt] = Field(default=None, description="Outcome for the client")
    profit_costs_ex_vat: Optional[StrictInt] = Field(default=None, description="Profit costs ex VAT")
    prior_authority_reference: Optional[StrictStr] = Field(default=None, description="Prior authority reference number")
    representation_order_date: Optional[date] = Field(default=None, description="Representation order date")
    stage_reached: Optional[StrictInt] = Field(default=None, description="Stage reached")
    substantive_hearing: Optional[StrictInt] = Field(default=None, description="Substantive hearing")
    travel_and_waiting_costs: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Travel & waiting costs")
    travel_time: Optional[StrictInt] = Field(default=None, description="Travel time")
    value_of_costs: Optional[StrictStr] = Field(default=None, description="Value of costs")
    waiting_time: Optional[StrictInt] = Field(default=None, description="Waiting time")
    __properties = ["additional_travel_payment", "adjourned_hearing_fee", "advocacy_costs", "advice_time", "bill_type", "case_concluded", "case_stage_level", "cla_exemption_code", "cla_reference", "cmrh_oral", "cmrh_telephone", "cost_of_counsel", "costs_are_those_of", "court_location", "date_of_claim", "designated_accredited_representative", "detention_travel_and_waiting_costs", "disbursements_vat", "exceptional_case_funding_reference", "exemption_criteria_satisfied", "follow_on_work", "ho_interview", "ho_ucn", "id", "independent_medical_reports_claimed", "jr_form_filling", "maat_id", "meetings_attended", "mht_ref_no", "net_disbursements", "net_profit_costs", "niat_disbursement_prior_authority_number", "number_of_attendances", "outcome_for_the_client", "profit_costs_ex_vat", "prior_authority_reference", "representation_order_date", "stage_reached", "substantive_hearing", "travel_and_waiting_costs", "travel_time", "value_of_costs", "waiting_time"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LegalAidUkBillBase:
        """Create an instance of LegalAidUkBillBase from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LegalAidUkBillBase:
        """Create an instance of LegalAidUkBillBase from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LegalAidUkBillBase.parse_obj(obj)

        _obj = LegalAidUkBillBase.parse_obj({
            "additional_travel_payment": obj.get("additional_travel_payment"),
            "adjourned_hearing_fee": obj.get("adjourned_hearing_fee"),
            "advocacy_costs": obj.get("advocacy_costs"),
            "advice_time": obj.get("advice_time"),
            "bill_type": obj.get("bill_type"),
            "case_concluded": obj.get("case_concluded"),
            "case_stage_level": obj.get("case_stage_level"),
            "cla_exemption_code": obj.get("cla_exemption_code"),
            "cla_reference": obj.get("cla_reference"),
            "cmrh_oral": obj.get("cmrh_oral"),
            "cmrh_telephone": obj.get("cmrh_telephone"),
            "cost_of_counsel": obj.get("cost_of_counsel"),
            "costs_are_those_of": obj.get("costs_are_those_of"),
            "court_location": obj.get("court_location"),
            "date_of_claim": obj.get("date_of_claim"),
            "designated_accredited_representative": obj.get("designated_accredited_representative"),
            "detention_travel_and_waiting_costs": obj.get("detention_travel_and_waiting_costs"),
            "disbursements_vat": obj.get("disbursements_vat"),
            "exceptional_case_funding_reference": obj.get("exceptional_case_funding_reference"),
            "exemption_criteria_satisfied": obj.get("exemption_criteria_satisfied"),
            "follow_on_work": obj.get("follow_on_work"),
            "ho_interview": obj.get("ho_interview"),
            "ho_ucn": obj.get("ho_ucn"),
            "id": obj.get("id"),
            "independent_medical_reports_claimed": obj.get("independent_medical_reports_claimed"),
            "jr_form_filling": obj.get("jr_form_filling"),
            "maat_id": obj.get("maat_id"),
            "meetings_attended": obj.get("meetings_attended"),
            "mht_ref_no": obj.get("mht_ref_no"),
            "net_disbursements": obj.get("net_disbursements"),
            "net_profit_costs": obj.get("net_profit_costs"),
            "niat_disbursement_prior_authority_number": obj.get("niat_disbursement_prior_authority_number"),
            "number_of_attendances": obj.get("number_of_attendances"),
            "outcome_for_the_client": obj.get("outcome_for_the_client"),
            "profit_costs_ex_vat": obj.get("profit_costs_ex_vat"),
            "prior_authority_reference": obj.get("prior_authority_reference"),
            "representation_order_date": obj.get("representation_order_date"),
            "stage_reached": obj.get("stage_reached"),
            "substantive_hearing": obj.get("substantive_hearing"),
            "travel_and_waiting_costs": obj.get("travel_and_waiting_costs"),
            "travel_time": obj.get("travel_time"),
            "value_of_costs": obj.get("value_of_costs"),
            "waiting_time": obj.get("waiting_time")
        })
        return _obj


