# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date, datetime
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr, validator
from clio-cli.models.activity_base import ActivityBase
from clio-cli.models.bill_base import BillBase
from clio-cli.models.discount_base import DiscountBase
from clio-cli.models.line_item_totals_base import LineItemTotalsBase
from clio-cli.models.matter_base import MatterBase
from clio-cli.models.user_base import UserBase

class LineItem(BaseModel):
    """
    LineItem
    """
    id: Optional[StrictInt] = Field(default=None, description="Unique identifier for the *LineItem*")
    etag: Optional[StrictStr] = Field(default=None, description="ETag for the *LineItem*")
    type: Optional[StrictStr] = Field(default=None, description="The type of the *LineItem*")
    description: Optional[StrictStr] = Field(default=None, description="The description for the *LineItem*")
    var_date: Optional[date] = Field(default=None, alias="date", description="The *LineItem* date (as a ISO-8601 date)")
    price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The price of the *LineItem*")
    taxable: Optional[StrictBool] = Field(default=None, description="Whether the *LineItem* is taxable")
    kind: Optional[StrictStr] = Field(default=None, description="The kind of *LineItem*")
    note: Optional[StrictStr] = Field(default=None, description="The note attached to the *LineItem*")
    secondary_taxable: Optional[StrictBool] = Field(default=None, description="Whether the *LineItem* is secondary taxable")
    total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The total amount for the *LineItem*")
    tax: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The tax amount for the *LineItem*")
    secondary_tax: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The secondary tax amount for the *LineItem*")
    sub_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The subtotal amount for the *LineItem*")
    quantity: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The amount of hours for the *LineItem*")
    group_ordering: Optional[StrictInt] = Field(default=None, description="The value to specify the ordering of the *LineItem* on a bill")
    created_at: Optional[datetime] = Field(default=None, description="The time the *LineItem* was created (as a ISO-8601 timestamp)")
    updated_at: Optional[datetime] = Field(default=None, description="The time the *LineItem* was last updated (as a ISO-8601 timestamp)")
    bill: Optional[BillBase] = None
    activity: Optional[ActivityBase] = None
    matter: Optional[MatterBase] = None
    user: Optional[UserBase] = None
    discount: Optional[DiscountBase] = None
    included_line_item_totals: Optional[LineItemTotalsBase] = None
    __properties = ["id", "etag", "type", "description", "date", "price", "taxable", "kind", "note", "secondary_taxable", "total", "tax", "secondary_tax", "sub_total", "quantity", "group_ordering", "created_at", "updated_at", "bill", "activity", "matter", "user", "discount", "included_line_item_totals"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('ActivityLineItem', 'LineItem', 'NoChargeLineItem', 'SummaryLineItem'):
            raise ValueError("must be one of enum values ('ActivityLineItem', 'LineItem', 'NoChargeLineItem', 'SummaryLineItem')")
        return value

    @validator('kind')
    def kind_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Service', 'Expense'):
            raise ValueError("must be one of enum values ('Service', 'Expense')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LineItem:
        """Create an instance of LineItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of bill
        if self.bill:
            _dict['bill'] = self.bill.to_dict()
        # override the default output from pydantic by calling `to_dict()` of activity
        if self.activity:
            _dict['activity'] = self.activity.to_dict()
        # override the default output from pydantic by calling `to_dict()` of matter
        if self.matter:
            _dict['matter'] = self.matter.to_dict()
        # override the default output from pydantic by calling `to_dict()` of user
        if self.user:
            _dict['user'] = self.user.to_dict()
        # override the default output from pydantic by calling `to_dict()` of discount
        if self.discount:
            _dict['discount'] = self.discount.to_dict()
        # override the default output from pydantic by calling `to_dict()` of included_line_item_totals
        if self.included_line_item_totals:
            _dict['included_line_item_totals'] = self.included_line_item_totals.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LineItem:
        """Create an instance of LineItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LineItem.parse_obj(obj)

        _obj = LineItem.parse_obj({
            "id": obj.get("id"),
            "etag": obj.get("etag"),
            "type": obj.get("type"),
            "description": obj.get("description"),
            "var_date": obj.get("date"),
            "price": obj.get("price"),
            "taxable": obj.get("taxable"),
            "kind": obj.get("kind"),
            "note": obj.get("note"),
            "secondary_taxable": obj.get("secondary_taxable"),
            "total": obj.get("total"),
            "tax": obj.get("tax"),
            "secondary_tax": obj.get("secondary_tax"),
            "sub_total": obj.get("sub_total"),
            "quantity": obj.get("quantity"),
            "group_ordering": obj.get("group_ordering"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "bill": BillBase.from_dict(obj.get("bill")) if obj.get("bill") is not None else None,
            "activity": ActivityBase.from_dict(obj.get("activity")) if obj.get("activity") is not None else None,
            "matter": MatterBase.from_dict(obj.get("matter")) if obj.get("matter") is not None else None,
            "user": UserBase.from_dict(obj.get("user")) if obj.get("user") is not None else None,
            "discount": DiscountBase.from_dict(obj.get("discount")) if obj.get("discount") is not None else None,
            "included_line_item_totals": LineItemTotalsBase.from_dict(obj.get("included_line_item_totals")) if obj.get("included_line_item_totals") is not None else None
        })
        return _obj


