# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist, validator
from clio-cli.models.address_base import AddressBase
from clio-cli.models.avatar_base import AvatarBase
from clio-cli.models.contact_base import ContactBase
from clio-cli.models.custom_field_value_base import CustomFieldValueBase
from clio-cli.models.email_address_base import EmailAddressBase
from clio-cli.models.phone_number_base import PhoneNumberBase
from clio-cli.models.relationship_base import RelationshipBase
from clio-cli.models.web_site_base import WebSiteBase

class MatterContacts(BaseModel):
    """
    MatterContacts
    """
    contact_created_at: Optional[datetime] = Field(default=None, description="Timestamp of the time the contact was created")
    contact_updated_at: Optional[datetime] = Field(default=None, description="Timestamp of the time the contact was created")
    created_at: Optional[datetime] = Field(default=None, description="The time the *MatterContacts* was created (as a ISO-8601 timestamp)")
    description: Optional[StrictStr] = Field(default=None, description="Description of the matter")
    etag: Optional[StrictStr] = Field(default=None, description="ETag for the *MatterContacts*")
    first_name: Optional[StrictStr] = Field(default=None, description="First name of the Person")
    id: Optional[StrictInt] = Field(default=None, description="Unique identifier for the *MatterContacts*")
    initials: Optional[StrictStr] = Field(default=None, description="The initials of the *MatterContacts*")
    is_client: Optional[StrictBool] = Field(default=None, description="Whether or not the MatterContacts is a client")
    last_name: Optional[StrictStr] = Field(default=None, description="Last name of the Person")
    matter_id: Optional[StrictInt] = Field(default=None, description="ID of the matter")
    matter_number: Optional[StrictStr] = Field(default=None, description="Number of the matter")
    middle_name: Optional[StrictStr] = Field(default=None, description="Middle name of the Person")
    name: Optional[StrictStr] = Field(default=None, description="The full name of the *MatterContacts*")
    prefix: Optional[StrictStr] = Field(default=None, description="The prefix of the *MatterContacts* (Mr, Mrs, etc)")
    primary_email_address: Optional[StrictStr] = Field(default=None, description="The primary email address associated with this *MatterContacts*.")
    primary_phone_number: Optional[StrictStr] = Field(default=None, description="The primary phone number associated with this *MatterContacts*.")
    relationship_name: Optional[StrictStr] = Field(default=None, description="The description of the relation between the contact and the matter, or \"Client\" if the user is the client.")
    secondary_email_address: Optional[StrictStr] = Field(default=None, description="The secondary email address of the contact")
    secondary_phone_number: Optional[StrictStr] = Field(default=None, description="The secondary phone number of the contact")
    title: Optional[StrictStr] = Field(default=None, description="The designated title of the *MatterContacts*")
    type: Optional[StrictStr] = Field(default=None, description="The type of the *MatterContacts*")
    updated_at: Optional[datetime] = Field(default=None, description="The time the *MatterContacts* was last updated (as a ISO-8601 timestamp)")
    client_connect_user_id: Optional[StrictInt] = Field(default=None, description="The client connect ID of the contacts associated user")
    avatar: Optional[AvatarBase] = None
    company: Optional[ContactBase] = None
    primary_address: Optional[AddressBase] = None
    primary_web_site: Optional[WebSiteBase] = None
    secondary_address: Optional[AddressBase] = None
    secondary_web_site: Optional[WebSiteBase] = None
    addresses: Optional[conlist(AddressBase)] = Field(default=None, description="Address")
    custom_field_values: Optional[conlist(CustomFieldValueBase)] = Field(default=None, description="CustomFieldValue")
    email_addresses: Optional[conlist(EmailAddressBase)] = Field(default=None, description="EmailAddress")
    phone_numbers: Optional[conlist(PhoneNumberBase)] = Field(default=None, description="PhoneNumber")
    web_sites: Optional[conlist(WebSiteBase)] = Field(default=None, description="WebSite")
    relationship: Optional[RelationshipBase] = None
    __properties = ["contact_created_at", "contact_updated_at", "created_at", "description", "etag", "first_name", "id", "initials", "is_client", "last_name", "matter_id", "matter_number", "middle_name", "name", "prefix", "primary_email_address", "primary_phone_number", "relationship_name", "secondary_email_address", "secondary_phone_number", "title", "type", "updated_at", "client_connect_user_id", "avatar", "company", "primary_address", "primary_web_site", "secondary_address", "secondary_web_site", "addresses", "custom_field_values", "email_addresses", "phone_numbers", "web_sites", "relationship"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Company', 'Person'):
            raise ValueError("must be one of enum values ('Company', 'Person')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> MatterContacts:
        """Create an instance of MatterContacts from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of avatar
        if self.avatar:
            _dict['avatar'] = self.avatar.to_dict()
        # override the default output from pydantic by calling `to_dict()` of company
        if self.company:
            _dict['company'] = self.company.to_dict()
        # override the default output from pydantic by calling `to_dict()` of primary_address
        if self.primary_address:
            _dict['primary_address'] = self.primary_address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of primary_web_site
        if self.primary_web_site:
            _dict['primary_web_site'] = self.primary_web_site.to_dict()
        # override the default output from pydantic by calling `to_dict()` of secondary_address
        if self.secondary_address:
            _dict['secondary_address'] = self.secondary_address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of secondary_web_site
        if self.secondary_web_site:
            _dict['secondary_web_site'] = self.secondary_web_site.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in addresses (list)
        _items = []
        if self.addresses:
            for _item in self.addresses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['addresses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in custom_field_values (list)
        _items = []
        if self.custom_field_values:
            for _item in self.custom_field_values:
                if _item:
                    _items.append(_item.to_dict())
            _dict['custom_field_values'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in email_addresses (list)
        _items = []
        if self.email_addresses:
            for _item in self.email_addresses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['email_addresses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in phone_numbers (list)
        _items = []
        if self.phone_numbers:
            for _item in self.phone_numbers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['phone_numbers'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in web_sites (list)
        _items = []
        if self.web_sites:
            for _item in self.web_sites:
                if _item:
                    _items.append(_item.to_dict())
            _dict['web_sites'] = _items
        # override the default output from pydantic by calling `to_dict()` of relationship
        if self.relationship:
            _dict['relationship'] = self.relationship.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> MatterContacts:
        """Create an instance of MatterContacts from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return MatterContacts.parse_obj(obj)

        _obj = MatterContacts.parse_obj({
            "contact_created_at": obj.get("contact_created_at"),
            "contact_updated_at": obj.get("contact_updated_at"),
            "created_at": obj.get("created_at"),
            "description": obj.get("description"),
            "etag": obj.get("etag"),
            "first_name": obj.get("first_name"),
            "id": obj.get("id"),
            "initials": obj.get("initials"),
            "is_client": obj.get("is_client"),
            "last_name": obj.get("last_name"),
            "matter_id": obj.get("matter_id"),
            "matter_number": obj.get("matter_number"),
            "middle_name": obj.get("middle_name"),
            "name": obj.get("name"),
            "prefix": obj.get("prefix"),
            "primary_email_address": obj.get("primary_email_address"),
            "primary_phone_number": obj.get("primary_phone_number"),
            "relationship_name": obj.get("relationship_name"),
            "secondary_email_address": obj.get("secondary_email_address"),
            "secondary_phone_number": obj.get("secondary_phone_number"),
            "title": obj.get("title"),
            "type": obj.get("type"),
            "updated_at": obj.get("updated_at"),
            "client_connect_user_id": obj.get("client_connect_user_id"),
            "avatar": AvatarBase.from_dict(obj.get("avatar")) if obj.get("avatar") is not None else None,
            "company": ContactBase.from_dict(obj.get("company")) if obj.get("company") is not None else None,
            "primary_address": AddressBase.from_dict(obj.get("primary_address")) if obj.get("primary_address") is not None else None,
            "primary_web_site": WebSiteBase.from_dict(obj.get("primary_web_site")) if obj.get("primary_web_site") is not None else None,
            "secondary_address": AddressBase.from_dict(obj.get("secondary_address")) if obj.get("secondary_address") is not None else None,
            "secondary_web_site": WebSiteBase.from_dict(obj.get("secondary_web_site")) if obj.get("secondary_web_site") is not None else None,
            "addresses": [AddressBase.from_dict(_item) for _item in obj.get("addresses")] if obj.get("addresses") is not None else None,
            "custom_field_values": [CustomFieldValueBase.from_dict(_item) for _item in obj.get("custom_field_values")] if obj.get("custom_field_values") is not None else None,
            "email_addresses": [EmailAddressBase.from_dict(_item) for _item in obj.get("email_addresses")] if obj.get("email_addresses") is not None else None,
            "phone_numbers": [PhoneNumberBase.from_dict(_item) for _item in obj.get("phone_numbers")] if obj.get("phone_numbers") is not None else None,
            "web_sites": [WebSiteBase.from_dict(_item) for _item in obj.get("web_sites")] if obj.get("web_sites") is not None else None,
            "relationship": RelationshipBase.from_dict(obj.get("relationship")) if obj.get("relationship") is not None else None
        })
        return _obj


