# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictStr, validator
from clio-cli.models.report_create_request_data_client import ReportCreateRequestDataClient
from clio-cli.models.report_create_request_data_matter import ReportCreateRequestDataMatter
from clio-cli.models.report_create_request_data_originating_attorney import ReportCreateRequestDataOriginatingAttorney
from clio-cli.models.report_create_request_data_practice_area import ReportCreateRequestDataPracticeArea

class ReportCreateRequestData(BaseModel):
    """
    ReportCreateRequestData
    """
    client: Optional[ReportCreateRequestDataClient] = None
    end_date: Optional[date] = Field(default=None, description="Filters Report data by date. (Expects an ISO-8601 date).")
    format: StrictStr = Field(default=..., description="What format the Report will be generated in.")
    kind: StrictStr = Field(default=..., description="What kind of Report will be generated.")
    matter: Optional[ReportCreateRequestDataMatter] = None
    originating_attorney: Optional[ReportCreateRequestDataOriginatingAttorney] = None
    practice_area: Optional[ReportCreateRequestDataPracticeArea] = None
    responsible_attorney: Optional[ReportCreateRequestDataOriginatingAttorney] = None
    start_date: Optional[date] = Field(default=None, description="Filters Report data by date. (Expects an ISO-8601 date).")
    user: Optional[ReportCreateRequestDataOriginatingAttorney] = None
    year: Optional[StrictStr] = Field(default=None, description="Filters Report data by year. Sets start_date and end_date. (Expects a year).")
    __properties = ["client", "end_date", "format", "kind", "matter", "originating_attorney", "practice_area", "responsible_attorney", "start_date", "user", "year"]

    @validator('format')
    def format_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('csv', 'html', 'json', 'pdf', 'xlsx', 'zip'):
            raise ValueError("must be one of enum values ('csv', 'html', 'json', 'pdf', 'xlsx', 'zip')")
        return value

    @validator('kind')
    def kind_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('accounts_receivable', 'accounts_receivable_aging', 'bank_account_activity', 'billing_history', 'billing_rate', 'client_activity', 'client_ledger', 'clio_payments_deposit', 'clio_payments_ledger', 'clio_payments_monthly_statement', 'clio_payments_sales_tax', 'clio_payments_transaction', 'contact_information', 'disbursement_payment', 'fee_allocation', 'general_ledger', 'grant_matters', 'invoice_payments_v2', 'law_society_of_alberta', 'law_society_of_alberta_al', 'law_society_of_alberta_bar', 'law_society_of_alberta_tl', 'law_society_of_alberta_tt', 'matter', 'matter_balance_summary', 'matter_productivity_by_user', 'matters_by_responsible_attorney', 'originating_attorney_revenue', 'other_revenue', 'productivity_by_client', 'productivity_by_user', 'revenue', 'task_productivity_by_user', 'task_progress_by_user', 'trust_ledger', 'trust_ledger_nsw', 'trust_listing', 'trust_management', 'work_in_progress'):
            raise ValueError("must be one of enum values ('accounts_receivable', 'accounts_receivable_aging', 'bank_account_activity', 'billing_history', 'billing_rate', 'client_activity', 'client_ledger', 'clio_payments_deposit', 'clio_payments_ledger', 'clio_payments_monthly_statement', 'clio_payments_sales_tax', 'clio_payments_transaction', 'contact_information', 'disbursement_payment', 'fee_allocation', 'general_ledger', 'grant_matters', 'invoice_payments_v2', 'law_society_of_alberta', 'law_society_of_alberta_al', 'law_society_of_alberta_bar', 'law_society_of_alberta_tl', 'law_society_of_alberta_tt', 'matter', 'matter_balance_summary', 'matter_productivity_by_user', 'matters_by_responsible_attorney', 'originating_attorney_revenue', 'other_revenue', 'productivity_by_client', 'productivity_by_user', 'revenue', 'task_productivity_by_user', 'task_progress_by_user', 'trust_ledger', 'trust_ledger_nsw', 'trust_listing', 'trust_management', 'work_in_progress')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ReportCreateRequestData:
        """Create an instance of ReportCreateRequestData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of client
        if self.client:
            _dict['client'] = self.client.to_dict()
        # override the default output from pydantic by calling `to_dict()` of matter
        if self.matter:
            _dict['matter'] = self.matter.to_dict()
        # override the default output from pydantic by calling `to_dict()` of originating_attorney
        if self.originating_attorney:
            _dict['originating_attorney'] = self.originating_attorney.to_dict()
        # override the default output from pydantic by calling `to_dict()` of practice_area
        if self.practice_area:
            _dict['practice_area'] = self.practice_area.to_dict()
        # override the default output from pydantic by calling `to_dict()` of responsible_attorney
        if self.responsible_attorney:
            _dict['responsible_attorney'] = self.responsible_attorney.to_dict()
        # override the default output from pydantic by calling `to_dict()` of user
        if self.user:
            _dict['user'] = self.user.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ReportCreateRequestData:
        """Create an instance of ReportCreateRequestData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ReportCreateRequestData.parse_obj(obj)

        _obj = ReportCreateRequestData.parse_obj({
            "client": ReportCreateRequestDataClient.from_dict(obj.get("client")) if obj.get("client") is not None else None,
            "end_date": obj.get("end_date"),
            "format": obj.get("format"),
            "kind": obj.get("kind"),
            "matter": ReportCreateRequestDataMatter.from_dict(obj.get("matter")) if obj.get("matter") is not None else None,
            "originating_attorney": ReportCreateRequestDataOriginatingAttorney.from_dict(obj.get("originating_attorney")) if obj.get("originating_attorney") is not None else None,
            "practice_area": ReportCreateRequestDataPracticeArea.from_dict(obj.get("practice_area")) if obj.get("practice_area") is not None else None,
            "responsible_attorney": ReportCreateRequestDataOriginatingAttorney.from_dict(obj.get("responsible_attorney")) if obj.get("responsible_attorney") is not None else None,
            "start_date": obj.get("start_date"),
            "user": ReportCreateRequestDataOriginatingAttorney.from_dict(obj.get("user")) if obj.get("user") is not None else None,
            "year": obj.get("year")
        })
        return _obj


