# coding: utf-8

"""
    Clio API Documentation

    # Developer Support and Feedback * Clio takes the availability and stability of our API seriously; please report any **degradations** or **breakages** to Clio's API Support team at [api@clio.com](mailto:api@clio.com). * For business and partnership inquiries, contact our API Partnerships team at [api.partnerships@clio.com](mailto:api.partnerships@clio.com). * For best practices and tips from the Clio development community, join the conversation in the [Clio Developer Slack Channel](https://join.slack.com/t/clio-public/shared_invite/zt-1bd5nfbiv-WloZR3ZjepoUTv28SI1ezw).  A community-driven [Clio Developers Stack Overflow Group](https://stackoverflow.com/questions/tagged/clio-api) also exists where you can connect and ask questions from other Clio API users. # Getting Started > **Note:** The API is available in four distinct data regions: Australia (au.app.clio.com), Canada (ca.app.clio.com), EU (eu.app.clio.com) and US (app.clio.com). > > Likewise, the developer portal is available at region-specific links for the [Australia](https://au.developers.clio.com), [Canada](https://ca.developers.clio.com), [EU](https://eu.developers.clio.com), and [US](https://developers.clio.com) regions. > > This document assumes the US region is being used (app.clio.com). If you're building in one of the other regions, you should adapt the links and examples as necessary.  To start building on the Clio API, you’ll need a Clio account – you can review our [Developer Handbook](https://docs.developers.clio.com/) and follow the steps to sign up for an account.  Once you have an account, you can [create a developer application](https://docs.developers.clio.com/api-docs/applications) from the [Developer Portal](https://developers.clio.com) and start building! # Authorization with OAuth 2.0 See our [Authorization documentation →](https://docs.developers.clio.com/api-docs/authorization) # Permissions See our [Permissions documentation →](https://docs.developers.clio.com/api-docs/permissions) # Fields See our [Fields documentation →](https://docs.developers.clio.com/api-docs/fields) # Rate Limiting See our [Rate Limits documentation →](https://docs.developers.clio.com/api-docs/rate-limits) # Paging See our [Pagination documentation →](https://docs.developers.clio.com/api-docs/paging) # ETags See our [ETags documentation →](https://docs.developers.clio.com/api-docs/etags) # Minor Versions API v4 supports multiple minor versions. Versions are of the form '4.X.Y'. To request a specific version, you can use an `X-API-VERSION` header in your request, with the header value set to the API version you're requesting. If this header is omitted, it will be treated as a request for the default API version. If the header is present but invalid, it will return a `410 Gone` response. If the header is present and valid, but it is no longer supported, it will return a `410 Gone` response.  An `X-API-VERSION` will be included in all successful responses, with the value being set to the API version used.  You can find our [API Versioning Policy and Guidelines](https://docs.developers.clio.com/api-docs/api-versioning-policy) in our documentation hub.  The [API Changelog](https://docs.developers.clio.com/api-docs/api-changelog) explains each version's changes in further detail. - 4.0.4    Update `quantity` field to return values in seconds rather than hours for Activities  - 4.0.5    * Remove `matter_balances` field from Bills   * Standardize status/state enum values   * Add a Document association to completed DocumentAutomations   * Add rate visibility handling for Activity's price and total  - 4.0.6    Remove `document_versions` collection field from Documents  - 4.0.7    Change secure link format  - 4.0.8    * `Activity` hours are redacted in the response based on the activity hours visibility setting for the user   * Add `quantity_redacted` field to activities  - 4.0.9    **This is the default version**    Contacts are filtered and redacted in the response based on the new 'Contacts Visibility' user permission setting.  - 4.0.10    Fixed validation of `type` query parameter when querying Notes   

    The version of the OpenAPI document: v4
    Contact: api@clio.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, validator
from clio-cli.models.task_create_request_data_matter import TaskCreateRequestDataMatter
from clio-cli.models.task_create_request_data_task_type import TaskCreateRequestDataTaskType
from clio-cli.models.task_update_request_data_assignee import TaskUpdateRequestDataAssignee

class TaskUpdateRequestData(BaseModel):
    """
    TaskUpdateRequestData
    """
    assignee: Optional[TaskUpdateRequestDataAssignee] = None
    cascading: Optional[StrictBool] = Field(default=None, description="Determines if the Task has a due date that is derived from another Task. (Note that if false, no other cascading information will be checked)")
    cascading_offset: Optional[StrictInt] = Field(default=None, description="The amount of time that will differentiate the cascaded Task from its parent.")
    cascading_offset_polarity: Optional[StrictStr] = Field(default=None, description="Determines whether or not the cascading_offset occurs before or after its parent.")
    cascading_offset_type: Optional[StrictStr] = Field(default=None, description="Determines the quantity of the cascading offset (e.g. CalendarDays, CalendarWeeks etc.)")
    cascading_source: Optional[StrictInt] = Field(default=None, description="The parent Task that is used to determine the due_at property of the cascaded Task")
    description: Optional[StrictStr] = Field(default=None, description="Longer description of the Task.")
    due_at: Optional[datetime] = Field(default=None, description="Date when the Task must be completed by. (Expects an ISO-8601 date).")
    matter: Optional[TaskCreateRequestDataMatter] = None
    name: Optional[StrictStr] = Field(default=None, description="Name of the Task.")
    notify_assignee: Optional[StrictBool] = Field(default=None, description="Whether or not the Task should notify the assignee on creation.")
    notify_completion: Optional[StrictBool] = Field(default=None, description="Whether or not the Task should notify the assigner on completion.")
    permission: Optional[StrictStr] = Field(default='public', description="Permission of the Task. Defaults to `public`")
    priority: Optional[StrictStr] = Field(default='Normal', description="Priority of the Task.")
    status: Optional[StrictStr] = Field(default='pending', description="Task status. Users without advanced tasks are allowed to select `Complete` or `Pending` only.")
    task_type: Optional[TaskCreateRequestDataTaskType] = None
    time_estimated: Optional[StrictInt] = Field(default=None, description="Time the Task should take to complete.")
    __properties = ["assignee", "cascading", "cascading_offset", "cascading_offset_polarity", "cascading_offset_type", "cascading_source", "description", "due_at", "matter", "name", "notify_assignee", "notify_completion", "permission", "priority", "status", "task_type", "time_estimated"]

    @validator('cascading_offset_polarity')
    def cascading_offset_polarity_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('CalendarDays', 'CalendarWeeks', 'CalendarMonths', 'CalendarYears', 'BusinessDays'):
            raise ValueError("must be one of enum values ('CalendarDays', 'CalendarWeeks', 'CalendarMonths', 'CalendarYears', 'BusinessDays')")
        return value

    @validator('cascading_offset_type')
    def cascading_offset_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Before', 'After'):
            raise ValueError("must be one of enum values ('Before', 'After')")
        return value

    @validator('permission')
    def permission_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('private', 'public'):
            raise ValueError("must be one of enum values ('private', 'public')")
        return value

    @validator('priority')
    def priority_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('High', 'Normal', 'Low'):
            raise ValueError("must be one of enum values ('High', 'Normal', 'Low')")
        return value

    @validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('pending', 'in_progress', 'in_review', 'complete'):
            raise ValueError("must be one of enum values ('pending', 'in_progress', 'in_review', 'complete')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TaskUpdateRequestData:
        """Create an instance of TaskUpdateRequestData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of assignee
        if self.assignee:
            _dict['assignee'] = self.assignee.to_dict()
        # override the default output from pydantic by calling `to_dict()` of matter
        if self.matter:
            _dict['matter'] = self.matter.to_dict()
        # override the default output from pydantic by calling `to_dict()` of task_type
        if self.task_type:
            _dict['task_type'] = self.task_type.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TaskUpdateRequestData:
        """Create an instance of TaskUpdateRequestData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TaskUpdateRequestData.parse_obj(obj)

        _obj = TaskUpdateRequestData.parse_obj({
            "assignee": TaskUpdateRequestDataAssignee.from_dict(obj.get("assignee")) if obj.get("assignee") is not None else None,
            "cascading": obj.get("cascading"),
            "cascading_offset": obj.get("cascading_offset"),
            "cascading_offset_polarity": obj.get("cascading_offset_polarity"),
            "cascading_offset_type": obj.get("cascading_offset_type"),
            "cascading_source": obj.get("cascading_source"),
            "description": obj.get("description"),
            "due_at": obj.get("due_at"),
            "matter": TaskCreateRequestDataMatter.from_dict(obj.get("matter")) if obj.get("matter") is not None else None,
            "name": obj.get("name"),
            "notify_assignee": obj.get("notify_assignee"),
            "notify_completion": obj.get("notify_completion"),
            "permission": obj.get("permission") if obj.get("permission") is not None else 'public',
            "priority": obj.get("priority") if obj.get("priority") is not None else 'Normal',
            "status": obj.get("status") if obj.get("status") is not None else 'pending',
            "task_type": TaskCreateRequestDataTaskType.from_dict(obj.get("task_type")) if obj.get("task_type") is not None else None,
            "time_estimated": obj.get("time_estimated")
        })
        return _obj


